﻿
local timer,temp,timer2 = 0,true,0
local O,Ot,Odk,Oo = {},{},{},{}
local TESTMODE = false
local VERSION = 1.3
local _,CLASS = UnitClass("player")
local NAME = UnitName("player")
local REALM = GetRealmName()
local DAMAGE = {}
for i=1,25 do DAMAGE[i] = 0 end
local DMG = 1
local PROFILE,PROFILENB
local DK_TALENT = 1
local DK_MASTERY,DK_SPE
------------- DK --------------
if CLASS == "DEATHKNIGHT" and Odk["enable"] then
	local _,_,_,_,x1 = GetTalentInfo(1, 18, false, false, nil)
	DK_TALENT = 1 + (0.15 * x1)
	if GetPrimaryTalentTree(false,false,GetActiveTalentGroup()) == 1 then
		DK_SPE = true
	else
		DK_SPE = false
	end
	DK_MASTERY = 0.0625 * GetMastery()
end
------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------ LIB
local LSM = LibStub("LibSharedMedia-3.0")
------------------------------------------
local M_statusbar = {}
for i=1,table.getn(LSM:List("statusbar")) do
   M_statusbar[i] = LSM:List("statusbar")[i]
end
local M_font = {}
for i=1,table.getn(LSM:List("font")) do
   M_font[i] = LSM:List("font")[i]
end
local M_border = {}
for i=1,table.getn(LSM:List("border")) do
   M_border[i] = LSM:List("border")[i]
end
local M_background = {}
for i=1,table.getn(LSM:List("background")) do
   M_background[i] = LSM:List("background")[i]
end
------------------------------------------









------------------------------------------
function Sh_OnLoad()
   ------------------------------------------
   
   
   
	-- Frame tooltip
	CreateFrame( "GameTooltip", "MiowTooltip", nil, "GameTooltipTemplate" )
	MiowTooltip:SetOwner( WorldFrame, "ANCHOR_NONE" )
	MiowTooltip:AddFontStrings(
		MiowTooltip:CreateFontString( "$parentTextLeft1", nil, "GameTooltipText" ),
		MiowTooltip:CreateFontString( "$parentTextRight1", nil, "GameTooltipText" )
	)
   
   
   -- Slash command
	SLASH_ShieldHealth1 = "/ShieldHealth"
	SLASH_ShieldHealth2 = "/sh"
	SLASH_ShieldHealth3 = "/sh toggle"
	SlashCmdList["ShieldHealth"] = function(self)
		print(self)
		InterfaceOptionsFrame_OpenToCategory("Shield Health")
	end
	
	
	
   -- Event
	Sh_EventFrame1 = CreateFrame("Frame", "MyEventFrame1", UIParent)
	Sh_EventFrame1:RegisterEvent("UNIT_AURA")
	Sh_EventFrame1:SetScript("OnEvent", Sh_EventFrame_OnEvent)
	Sh_EventFrame1bis = CreateFrame("Frame", "MyEventFrame1bis", UIParent)
	Sh_EventFrame1bis:RegisterEvent("PLAYER_TARGET_CHANGED")
	Sh_EventFrame1bis:SetScript("OnEvent", Sh_EventFrame_OnEvent)
	
	Sh_EventFrame2 = CreateFrame("Frame", "MyEventFrame2", UIParent)
	Sh_EventFrame2:RegisterEvent("VARIABLES_LOADED")
	Sh_EventFrame2:SetScript("OnEvent", Sh_opt_LOAD)
	Sh_EventFrame3 = CreateFrame("Frame", "MyEventFrame3", UIParent)
	Sh_EventFrame3:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	Sh_EventFrame3:SetScript("OnEvent", Sh_EventFrame3_OnEvent)


	if CLASS == "DEATHKNIGHT" and Odk["enable"] then
		Sh_EventFrameDK = CreateFrame("Frame", "MyEventFrameDK", UIParent)
		Sh_EventFrameDK:RegisterEvent("PLAYER_TALENT_UPDATE")
		Sh_EventFrameDK:SetScript("OnEvent", function()
				local _,_,_,_,x1 = GetTalentInfo(1, 18, false, false, nil)
				DK_TALENT = 1 + (0.15 * x1)
			end
		)
		Sh_EventFrameDK2 = CreateFrame("Frame", "MyEventFrameDK2", UIParent)
		Sh_EventFrameDK2:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
		Sh_EventFrameDK2:SetScript("OnEvent", function()
				local _,_,_,_,x1 = GetTalentInfo(1, 18, false, false, nil)
				DK_TALENT = 1 + (0.15 * x1)
				DK_SPE = GetPrimaryTalentTree(false,false,GetActiveTalentGroup())
			end
		)
		Sh_EventFrameDK3 = CreateFrame("Frame", "MyEventFrameDK3", UIParent)
		Sh_EventFrameDK3:RegisterEvent("MASTERY_UPDATE")
		Sh_EventFrameDK3:SetScript("OnEvent", function()
				DK_MASTERY = 0.0625 * GetMastery()
			end
		)
	end
	
   -- Timer
   timer = 0
   local timerframe = CreateFrame("frame")
   timerframe:SetScript("OnUpdate", Sh_timer)
   timer2 = 0
   local timerframe2 = CreateFrame("frame")
   timerframe2:SetScript("OnUpdate", Sh_timer2)
   
   -- Fonctions
   
   Sh_options()
   Sh_createBar()
   Sh_OnEvent()
 
end


function Sh_options()
   -- Lancé après VARIABLES_LOADED
   ------------------------------------------
   
   ------------------------
   -- Options par défaut --
   ------------------------
		O["enable"] = true
		O["short"] = false
		O["blink"] = true
		

		O["f:largeur"] = 210 -- Largeur barre du fond
		O["f:hauteur"] = 30 -- Hauteur barre du fond
		O["iconsize"] = 20 -- Taille des icones
		O["level"] = 1
		O["f:pos:1"] = "CENTER"
		O["f:pos:2"] = nil
		O["f:pos:3"] = "CENTER"
		O["f:pos:4"] = 0
		O["f:pos:5"] = -50
		
		O["tex_barre"] = "Interface\\PaperDollInfoFrame\\UI-Character-Skills-Bar" -- Texture des barres des boucliers
		O["f:tex:fond"] = "Interface\\Tooltips\\UI-Tooltip-Background" -- Texture du fond de la barre du fond
		O["f:tex:border"] = "Interface\\Tooltips\\UI-Tooltip-Border" -- Texture de la bordeure de la barre du fond
		O["font:val"] = "Fonts\\FRIZQT__.TTF" -- Text de la valeur des boucliers
		
		O["border:size"] = 4
		O["insets:left"] = 2
		O["insets:right"] = 2
		O["insets:top"] = 2
		O["insets:bottom"] = 2
		
		
		O["font:val:size"] = 18
		O["font:val:r"] = 0.8
		O["font:val:v"] = 1
		O["font:val:b"] = 0.9
		O["font:val:a"] = 1
		O["outline"] = false

		O["f:SBC:r"] = 1 -- Couleur du fond des barres
		O["f:SBC:v"] = 1
		O["f:SBC:b"] = 1
		O["f:SBC:a"] = 0.5

		O["b:a"] = 100

		O["1:r"] = 0 -- Couleur des barres des boucliers
		O["1:v"] = 0
		O["1:b"] = 1
		O["2:r"] = 1
		O["2:v"] = 1
		O["2:b"] = 1
		O["3:r"] = 1
		O["3:v"] = 0
		O["3:b"] = 0
		O["4:r"] = 1
		O["4:v"] = 1
		O["4:b"] = 0
		O["5:r"] = 1
		O["5:v"] = 0.95
		O["5:b"] = 0.77
		O["6:r"] = 0.8
		O["6:v"] = 1
		O["6:b"] = 1
		O["7:r"] = 1
		O["7:v"] = 0.7
		O["7:b"] = 0
		O["8:r"] = 0
		O["8:v"] = 0.7
		O["8:b"] = 0
		O["9:r"] = 0
		O["9:v"] = 0.7
		O["9:b"] = 0


		Ot["enable"] = true
		Ot["enable_extase"] = true
		Ot["short"] = false
		Ot["blink"] = true
		

		Ot["f:largeur"] = 210 -- Largeur barre du fond
		Ot["f:hauteur"] = 30 -- Hauteur barre du fond
		Ot["iconsize"] = 20 -- Taille des icones
		Ot["level"] = 1
		Ot["f:pos:1"] = "CENTER"
		Ot["f:pos:2"] = nil
		Ot["f:pos:3"] = "CENTER"
		Ot["f:pos:4"] = 0
		Ot["f:pos:5"] = -100

		Ot["tex_barre"] = "Interface\\PaperDollInfoFrame\\UI-Character-Skills-Bar" -- Texture des barres des boucliers
		Ot["f:tex:fond"] = "Interface\\Tooltips\\UI-Tooltip-Background" -- Texture du fond de la barre du fond
		Ot["f:tex:border"] = "Interface\\Tooltips\\UI-Tooltip-Border" -- Texture de la bordeure de la barre du fond
		Ot["font:val"] = "Fonts\\FRIZQT__.TTF" -- Text de la valeur des boucliers
	
		Ot["border:size"] = 5
		
		Ot["font:val:size"] = 18
		Ot["font:val:r"] = 0.8
		Ot["font:val:v"] = 1
		Ot["font:val:b"] = 0.9
		Ot["font:val:a"] = 1
		Ot["outline"] = false

		Ot["f:SBC:r"] = 1 -- Couleur du fond des barres
		Ot["f:SBC:v"] = 1
		Ot["f:SBC:b"] = 1
		Ot["f:SBC:a"] = 0.5
		
		Ot["border:size"] = 4
		Ot["insets:left"] = 2
		Ot["insets:right"] = 2
		Ot["insets:top"] = 2
		Ot["insets:bottom"] = 2

		Ot["b:a"] = 100

		Ot["1:r"] = 0 -- Couleur des barres des boucliers
		Ot["1:v"] = 0
		Ot["1:b"] = 1
		Ot["2:r"] = 1
		Ot["2:v"] = 1
		Ot["2:b"] = 1
		Ot["3:r"] = 1
		Ot["3:v"] = 0
		Ot["3:b"] = 0
		Ot["4:r"] = 1
		Ot["4:v"] = 1
		Ot["4:b"] = 0
		Ot["5:r"] = 1
		Ot["5:v"] = 0.95
		Ot["5:b"] = 0.77
		Ot["6:r"] = 0.8
		Ot["6:v"] = 1
		Ot["6:b"] = 1
		Ot["7:r"] = 1
		Ot["7:v"] = 0.7
		Ot["7:b"] = 0
		Ot["8:r"] = 0
		Ot["8:v"] = 0.7
		Ot["8:b"] = 0
		Ot["9:r"] = 0
		Ot["9:v"] = 0.7
		Ot["9:b"] = 0
		
		
		
		
		Odk["enable"] = false
		Odk["enable_extase"] = true
		Odk["short"] = false
		Odk["blink"] = true
		

		Odk["f:largeur"] = 210 -- Largeur barre du fond
		Odk["f:hauteur"] = 30 -- Hauteur barre du fond
		Odk["level"] = 1
		Odk["f:pos:1"] = "CENTER"
		Odk["f:pos:2"] = nil
		Odk["f:pos:3"] = "CENTER"
		Odk["f:pos:4"] = 0
		Odk["f:pos:5"] = -150

		Odk["tex_barre"] = "Interface\\PaperDollInfoFrame\\UI-Character-Skills-Bar" -- Texture des barres des boucliers
		Odk["f:tex:fond"] = "Interface\\Tooltips\\UI-Tooltip-Background" -- Texture du fond de la barre du fond
		Odk["f:tex:border"] = "Interface\\Tooltips\\UI-Tooltip-Border" -- Texture de la bordeure de la barre du fond
		Odk["font:val"] = "Fonts\\FRIZQT__.TTF" -- Text de la valeur des boucliers
	
		Odk["border:size"] = 5
		
		Odk["font:val:size"] = 18
		Odk["font:val:r"] = 0.8
		Odk["font:val:v"] = 1
		Odk["font:val:b"] = 0.9
		Odk["font:val:a"] = 1
		Odk["outline"] = false

		Odk["f:SBC:r"] = 1 -- Couleur du fond des barres
		Odk["f:SBC:v"] = 1
		Odk["f:SBC:b"] = 1
		Odk["f:SBC:a"] = 0.5
		
		Odk["border:size"] = 4
		Odk["insets:left"] = 2
		Odk["insets:right"] = 2
		Odk["insets:top"] = 2
		Odk["insets:bottom"] = 2

		Odk["b:a"] = 100

		Odk["1:r"] = 1 -- Couleur des barres des boucliers
		Odk["1:v"] = 0.2
		Odk["1:b"] = 0.1
		
		
		
		
		Oo["Ord"] = {1,2,3,4,5,6,7,8,9}
		Oo["Ord:toggle"] = {true,true,true,true,true,true,true,true,true}
		Oo["Ord:icon"] = {true,true,true,true,true,true,true,true,true}
		Oo["enable_extase"] = true
end

------------------------------------------ Variables
------------------------------------------------------------------------------------

------------------------------------------ Tables bouclier
local B = {} -- Nom
local Bv = {0,0,0,0,0,0,0,0,0} -- Valeur
local Bmv = {0,0,0,0,0,0,0,0,0} -- Valeur max
local Bt = {0,0,0,0,0,0,0,0,0} -- Temps
local Bmt = {0,0,0,0,0,0,0,0,0} -- Temps max
local Blt = {0,0,0,0,0,0,0,0,0} -- Temps de lancement
local Bf = {0,0,0,0,0,0,0,0,0} -- Frames barres status bouclier
local Bf_tex = {0,0,0,0,0,0,0,0,0}
------
local Bvtar = {0,0,0,0,0,0,0,0,0} -- Valeur
local Bmvtar = {0,0,0,0,0,0,0,0,0} -- Valeur max
local Bttar = {0,0,0,0,0,0,0,0,0} -- Temps
local Bmttar = {0,0,0,0,0,0,0,0,0} -- Temps max
local Blttar = {0,0,0,0,0,0,0,0,0} -- Temps de lancement
local Bftar = {0,0,0,0,0,0,0,0,0} -- Frames barres status bouclier
local Bf_textar = {0,0,0,0,0,0,0,0,0}
------------------------------------------
local bg,blink,f,ft1,fb,fb2,i1,i2 -- Frames
local bgtar,blinktar,ftar,fbtar,fb2tar,ft1tar,i1tar,i2tar-- Frame target
local bgDK,fDK,ft1DK,fbDK,fb2DK-- Frame DK

local Bf_tex,color,color_tex,color_text = {},{},{},{}
local Bf_textar,colortar,color_textar,color_texttar = {},{},{},{}
local ordre,up_ordre,down_ordre,text_ordre,toggle_ordre,toggle_icon = {},{},{},{},{},{}

local Profile_SF_frame,Profile_SF_text = {},{}

-- Options
local slider,slidermoins,sliderplus = {},{},{}
local Sh_DDM,Sh_DDM_items,Sh_DDM_var,Sh_DDM_type,Sh_DDM_tar = {},{},{},{},{}
local cb = {}
local btn = {}
local cp = {}
local i1_tex,i2_tex
local color_fontval_tex = {}
local b_verr
--

local blinkbool = false


local totalmax,total
local slot = {}
for j=1,25 do
	slot[j] = {0,0,0,0,0,0,0,0,0,0,0,0}
end
	
	

------------------------------------------ Localisation
------------------------------------------------------------------------------------


local L = sh_Local
------------------------------------------------------------------------------------
local raptureTIME = 0


------------------------------------------ Tables
------------------------------------------------------------------------------------

------------------------------------------ Icons
local Btex = { "spell_ice_lament",  "spell_shadow_detectlesserinvisibility", "spell_shadow_sacrificialshield", "ability_paladin_blessedmending", "Spell_holy_PowerWordShield", "Spell_Holy_DevineAegis", "spell_holy_absolution", "ability_racial_cannibalize", "spell_deathknight_butcher2"}
for i=1,9 do Btex[i] =  "Interface\\Icons\\" .. Btex[i] end

local Bid = {11426, 1463, 7812, 85285, 17, 47753, 76669, 62600, 77535}

local B = {}
for i=1,9 do
	B[i] = GetSpellInfo(Bid[i])
end
------------------------------------------------------------------------------------






------------------------------------------ Fonctions
------------------------------------------------------------------------------------




------------------------------------------
function Sh_timer(self,elapsed)
   -- Fonction indépendante - met à jour le temps restant des boucliers
   ------------------------------------------
	timer = timer + elapsed
	local temps = math.floor(timer * 10)
	if temps%2 == 0 then
		if temp then
			temp = false
			if temps == 4 or temps == 8 then
				if GetTime() - raptureTIME > 12 then
					raptureFRAME:Hide()
				end
			end
			if CLASS == "DEATHKNIGHT" and Odk["enable"] then
				DMG = DMG + 1
				if DMG == 26 then
					DMG = 1
				end
				DAMAGE[DMG] = 0
				Sh_DK_update()
			end
			
		end
	else
		temp = true
	end
	if timer > 1 then timer = 0 Sh_OnEvent() end

end  
    

function Sh_timer2(self,elapsed)
	timer2 = timer2 + elapsed
	if (blinkbool and O["blink"]) or (blinkbooltar and Ot["blink"]) then
		if (timer2 >= 0.22 and timer2 <= 0.27) or (timer2 >= 0.72 and timer2 <= 0.77) then
			if blinkbool and O["blink"] then blink:SetBackdropColor(1,0,0,0.5) end
			if blinkbooltar and Ot["blink"] then blinktar:SetBackdropColor(1,0,0,0.5) end
		elseif (timer2 >= 0.48 and timer2 <= 0.52) or (timer2 >= 1) then 
			if blinkbool and O["blink"] then blink:SetBackdropColor(1,0,0,0) end
			if blinkbooltar and Ot["blink"] then blinktar:SetBackdropColor(1,0,0,0) end
		end
	end
	if not(blinkbool and O["blink"]) then blink:SetBackdropColor(1,0,0,0) end
	if not(blinkbooltar and Ot["blink"]) then blinktar:SetBackdropColor(1,0,0,0) end
	
	if timer2 >= 1 then
		timer2 = 0
	end
end

------------------------------------------
function Sh_OnEvent()
   -- Appelé sur un UNIT_AURA
   ------------------------------------------
	if not(TESTMODE) then

	local function Sh_Shield(i,s,bool)
		if s == nil then
			if Oo["Ord:toggle"][i] then
				Sh_newShield(i)
			else
				Bt[i]=0
				Bv[i]=0
				Bmv[i]=0
			end
		else
			if Oo["Ord:toggle"][i] and bool then
				Sh_newShieldtar(i,s)
			else
				slot[s][i] = 0
				Bvtar[i],Bttar[i],Bmttar[i] = 0,0,0
				totalmax = totalmax + slot[s][i]
				total = total + Bvtar[i]
			end
		end
	end
	
	local unit = "player"

	if CLASS == "MAGE" then
		Sh_Shield(1)
		Sh_Shield(2)
		Sh_Shield(3)
	end
   	if CLASS == "WARLOCK" then
		Sh_Shield(3)
	end
	if CLASS == "PALADIN" then
		Sh_Shield(4)
	end
	if CLASS == "DEATHKNIGHT" then
		Sh_Shield(9)
	end
	if CLASS == "DRUID" then
		Sh_Shield(8)
	end
	Sh_Shield(5)
	Sh_Shield(6)
	Sh_Shield(7)
	
------------------------------------------



	local unit = "target"
	total,totalmax = 0,0
	local s = Sh_tar_slot(UnitName(unit))
	local _,classtar = UnitClass("target")
	if classtar == "MAGE" then
		Sh_Shield(1,s,true)
		Sh_Shield(2,s,true)
	else
		Sh_Shield(1,s,false)
		Sh_Shield(2,s,false)
	end
	
   	if classtar == "WARLOCK" or classtar == "MAGE" then
		Sh_Shield(3,s,true)
	else
		Sh_Shield(3,s,false)
	end
	
	if classtar == "PALADIN" then
		Sh_Shield(4,s,true)
	else
		Sh_Shield(4,s,false)
	end
	
	if classtar == "DEATHKNIGHT" then
		Sh_Shield(9,s,true)
	else
		Sh_Shield(9,s,false)
	end
	
	if classtar == "DRUID" then
		Sh_Shield(8,s,true)
	else
		Sh_Shield(8,s,false)
	end
	
	Sh_Shield(5,s,true)
	Sh_Shield(6,s,true)
	Sh_Shield(7,s,true)
   

	
	if total ~= 0 then
		slot[s][11] = UnitName(unit)
		slot[s][12] = GetTime()
		
	end
	Sh_tar_update(Bvtar,total,totalmax,Bttar,Bmttar)
end 
end

------------------------------------------   
function Sh_newShieldtar(i,s)
	-- 
	------------------------------------------   
	local unit = "target"
	local x1
	x1,_,_,_,_,Bmttar[i],Bttar[i] = UnitBuff(unit,B[i])
	Bvtar[i] = 0
	if x1 == nil then
		Bttar[i],Bmttar[i] = 0,0 
	else
		Bvtar[i] = Sh_val(unit,B[i])
	end
	-- temps,tempsmax,Val
	
	if Bvtar[i] == 0 then
		slot[s][i] = 0
	elseif slot[s][i] < Bvtar[i] then
		slot[s][i] = Bvtar[i]
	end
	totalmax = totalmax + slot[s][i]
	total = total + Bvtar[i]
end
	
------------------------------------------   
function Sh_tar_slot(name)
	-- Selectionne un slot libre ou celui déjà existant de la cible
	------------------------------------------
	if name ~= nil then
		for j=1,25 do
			if slot[j][11] == name then
				return j
			end
		end
	end
	
	for j=1,25 do
		if slot[j] == nil then
			return j
		end
	end

	for j=1,25 do
		if (GetTime()) - slot[j][12] > 60 then
		return j
		end
	end
	return 1
	

end



   

   
   
function Sh_tar_update(valB,valtotB,valmaxtotB,tempsB,tempsmaxB)
   -- met à jour la barre de la cible
   ------------------------------------------
   
 
   ---------------------------
   -- Si il n'y a aucun bouclier
   if valmaxtotB <= 1 then
		blinkbooltar = false
		blinktar:SetBackdropColor(1,0,0,0)
		ftar:Hide()
		ft1tar:SetText("")
      ---------------------------
      ---------------------------
      -- Si il y a des boucliers
   else
      
	local x5 = math.floor(valtotB / 1000)
	local x6 = (valtotB - (1000 * x5))
	if not(Ot["short"]) then
		if x5 == 0 then
			ft1tar:SetText(x6)
		elseif x6 >= 100 then
			ft1tar:SetText(x5 .. " " .. x6)
		elseif x6 >= 10 then 
			ft1tar:SetText(x5 .. " 0" .. x6) 
		else
			ft1tar:SetText(x5 .. " 00" .. x6)
		end
	else
		if x5 ~= 0 then
			ft1tar:SetText(x5 .. "k")
		else
			ft1tar:SetText(x6)
		end
	end		
		
      
      -- Blink ------
		if (valtotB / valmaxtotB) <= 0.20 then
			blinkbooltar = true
		else
			blinkbooltar = false
			blinktar:SetBackdropColor(1,0,0,0)
		end
	  
	  --------------- 
	  
	  
      ftar:Show()
      i1tar:Hide()
	  i2tar:Hide()
          
      local x1,x2,x3,x4 = 0,0,true,true
      
		for i,j in pairs(Oo["Ord"]) do
         	if valB[j] >= 1 and Oo["Ord:icon"][j] then
				if x3 then
					i1_textar:SetTexture(Btex[j])
					i1tar:Show()
					i1CDtar:SetCooldown(GetTime()-(tempsmaxB[j]-(tempsB[j] - GetTime())), tempsmaxB[j])
					x3 = false
				elseif x4 then
					i2_textar:SetTexture(Btex[j])
					i2tar:Show()
					i2CDtar:SetCooldown(GetTime()-(tempsmaxB[j]-(tempsB[j] - GetTime())), tempsmaxB[j])
					x4 = false
				end
		    end   
		end  
		
		for i,j in pairs(Oo["Ord"]) do
			if valB[j] >= 1 then
				if not(x4) then 
					x2=(Ot["f:largeur"]-(Ot["iconsize"]*2 + Ot["insets:left"]+Ot["insets:right"]))/(valmaxtotB/valB[j])
					fbtar:SetPoint("LEFT",Ot["iconsize"]*2+Ot["insets:left"],((Ot["insets:bottom"]-Ot["insets:top"])/2))
					fbtar:SetWidth(Ot["f:largeur"]-(Ot["iconsize"]*2 + Ot["insets:left"]+Ot["insets:right"]))
					fb2tar:SetPoint("LEFT",Ot["iconsize"]*2 +Ot["insets:left"],((Ot["insets:bottom"]-Ot["insets:top"])/2))
					fb2tar:SetWidth(Ot["f:largeur"]-(Ot["iconsize"]*2 + Ot["insets:left"]+Ot["insets:right"]))
					
				elseif not(x3) then
					x2=(Ot["f:largeur"]-(Ot["iconsize"] + Ot["insets:left"]+Ot["insets:right"]))/(valmaxtotB/valB[j])
					fbtar:SetPoint("LEFT",Ot["iconsize"]+Ot["insets:left"],((Ot["insets:bottom"]-Ot["insets:top"])/2))
					fbtar:SetWidth(Ot["f:largeur"]-(Ot["iconsize"] + Ot["insets:left"]+Ot["insets:right"]))
					fb2tar:SetPoint("LEFT",Ot["iconsize"] +Ot["insets:left"],((Ot["insets:bottom"]-Ot["insets:top"])/2))
					fb2tar:SetWidth(Ot["f:largeur"]-(Ot["iconsize"] + Ot["insets:left"]+Ot["insets:right"]))
				else
					x2=(Ot["f:largeur"]-(Ot["insets:left"]+Ot["insets:right"]))/(valmaxtotB/valB[j])
					fbtar:SetPoint("LEFT",Ot["insets:left"],((Ot["insets:bottom"]-Ot["insets:top"])/2))
					fbtar:SetWidth(Ot["f:largeur"]-(Ot["insets:left"]+Ot["insets:right"]))
					fb2tar:SetPoint("LEFT",Ot["insets:left"],((Ot["insets:bottom"]-Ot["insets:top"])/2))
					fb2tar:SetWidth(Ot["f:largeur"]-(Ot["insets:left"]+Ot["insets:right"]))
				end
				Bftar[j]:Show()
				Bftar[j]:SetWidth(x2)
				Bftar[j]:SetPoint("LEFT",x1,0)
			else
				Bftar[j]:SetWidth(1)
				Bftar[j]:Hide()
			end
			x1 = x1 + x2
			x2 = 0
		end
   end
end  
   
   
   
   
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

------------------------------------------------------------------------------------
------------------------------------------------------------------------------------  
------------------------------------------   
function Sh_newShield(i)
--
------------------------------------------   
	local unit = "player"
	if Sh_check_buff(unit,B[i],i) then
		if Bmv[i] == 0 then
		f:Show()
		Bt[i] = Bmt[i]
		Bmv[i] = Bv[i]
		end
	end
	if Bv[i]/100000 >= Bmv[i]/100000 then --WTF? Fix, ne fonctionnait pas pour des valeurs de bouclier > 10 k ...
		Bmv[i] = Bv[i]
	end
	Sh_update(unit,B[i],i)
end

   
 

------------------------------------------
function Sh_check_buff(unit,nom,i)
   -- Test si le buff est présent sur unit
   ------------------------------------------
   	local temp,_,_,_,_,x1,x2 = UnitBuff(unit,nom)
	if (temp ==  nil) then
		Bv[i] = 0
		Bmv[i] =  0
		return false
	else
		Bt[i] = x2 - GetTime()
		Bmt[i] = x1
		Bv[i] = Sh_val(unit,nom)
		return true
	end
end


------------------------------------------
function Sh_val(unit, nom)
   -- Lis la valeur du bouclier dans le tooltip
   ------------------------------------------  
   
   
   MiowTooltip:ClearLines()
   MiowTooltip:SetUnitBuff(unit,nom)
   
   local val = tostring(_G["MiowTooltipTextLeft"..2]:GetText())
   val = string.match(val,"%d+")
   
   
   return tonumber(val)
end



------------------------------------------
function Sh_update(unit,nom,i)
   -- met à jour la barre
   ------------------------------------------
   
   
   ---------------------------
   local uBmv,uBv = 0,0
   for j=1,table.getn(Bmv) do
      uBmv = uBmv + Bmv[j]
   end
   for j=1,table.getn(Bv) do
      uBv = uBv + Bv[j]
   end
   ---------------------------
   
   ---------------------------
   -- Si il n'y a aucun bouclier
	if uBmv < 1 or uBmv == nil then
		blinkbool = false
		f:Hide()
		ft1:SetText("")
      ---------------------------
      ---------------------------
      -- Si il y a des boucliers
	else
      
	local x5 = math.floor(uBv / 1000)
	local x6 = (uBv - (1000 * x5))
	if not(O["short"]) then
		if x5 == 0 then
			ft1:SetText(x6)
		elseif x6 >= 100 then
			ft1:SetText(x5 .. " " .. x6)
		elseif x6 >= 10 then 
			ft1:SetText(x5 .. " 0" .. x6) 
		else
			ft1:SetText(x5 .. " 00" .. x6)
		end
	else
		if x5 ~= 0 then
			ft1:SetText(x5 .. "k")
		else
			ft1:SetText(x6)
		end
	end		
		
		
		
		
      
      -- Blink ------
		if (uBv / uBmv) <= 0.20 then
			blinkbool = true
		else
			blinkbool = false
			blink:SetBackdropColor(1,0,0,0)
		end
	  
	  --------------- 
	  
	  
      f:Show()
      i1:Hide()
	  i2:Hide()
      icon1,icon2 = 0,0
      
      local x1,x2,x3,x4 = 0,0,true,true
      
		for i,j in pairs(Oo["Ord"]) do
         	if Bv[j] >= 1 and Oo["Ord:icon"][j] then
				if x3 then
					i1_tex:SetTexture(Btex[j])
					i1:Show()
					i1CD:SetCooldown(GetTime()-(Bmt[j]-Bt[j]), Bmt[j])
					x3 = false
				elseif x4 then
					i2_tex:SetTexture(Btex[j])
					i2:Show()
					i2CD:SetCooldown(GetTime()-(Bmt[j]-Bt[j]), Bmt[j])
					x4 = false
				end
		    end   
		end  
		
		x1 = 0
		for i,j in pairs(Oo["Ord"]) do
			if Bv[j] >= 1 then
				if not(x4) then 
					x2=(O["f:largeur"]-(O["iconsize"]*2 + O["insets:left"]+O["insets:right"]))/(uBmv/Bv[j])
					fb:SetPoint("LEFT",O["iconsize"]*2+O["insets:left"],((O["insets:bottom"]-O["insets:top"])/2))
					fb:SetWidth(O["f:largeur"]-(O["iconsize"]*2 + O["insets:left"]+O["insets:right"]))
					fb2:SetPoint("LEFT",O["iconsize"]*2 +O["insets:left"],((O["insets:bottom"]-O["insets:top"])/2))
					fb2:SetWidth(O["f:largeur"]-(O["iconsize"]*2 + O["insets:left"]+O["insets:right"]))
					
				elseif not(x3) then
					x2=(O["f:largeur"]-(O["iconsize"] + O["insets:left"]+O["insets:right"]))/(uBmv/Bv[j])
					fb:SetPoint("LEFT",O["iconsize"]+O["insets:left"],((O["insets:bottom"]-O["insets:top"])/2))
					fb:SetWidth(O["f:largeur"]-(O["iconsize"] + O["insets:left"]+O["insets:right"]))
					fb2:SetPoint("LEFT",O["iconsize"] +O["insets:left"],((O["insets:bottom"]-O["insets:top"])/2))
					fb2:SetWidth(O["f:largeur"]-(O["iconsize"] + O["insets:left"]+O["insets:right"]))
				else
					x2=(O["f:largeur"]-(O["insets:left"]+O["insets:right"]))/(uBmv/Bv[j])
					fb:SetPoint("LEFT",O["insets:left"],((O["insets:bottom"]-O["insets:top"])/2))
					fb:SetWidth(O["f:largeur"]-(O["insets:left"]+O["insets:right"]))
					fb2:SetPoint("LEFT",O["insets:left"],((O["insets:bottom"]-O["insets:top"])/2))
					fb2:SetWidth(O["f:largeur"]-(O["insets:left"]+O["insets:right"]))
				end
				Bf[j]:Show()
				Bf[j]:SetWidth(x2)
				Bf[j]:SetPoint("LEFT",x1,0)
			else
				Bf[j]:SetWidth(1) Bf[j]:Hide()
			end
			x1 = x1 + x2   
			x2 = 0
		end
   end
end

------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

------------------------------------------------------------------------------------
------------------------------------------------------------------------------------





function Sh_DK_update()
if not(TESTMODE) then
	local val = 0
	for i,k in pairs(DAMAGE) do
		val = k + val
	end
	local vie = (0.07 * UnitHealthMax("player"))
	val = (0.2 * val * DK_TALENT)
	
	if vie > val then
		val = vie
	end
	
	local shield = DK_MASTERY * val
	
	if val < 1 then
		bgDK:Hide()
		ft1DK:SetText("")
		---------------------------
		---------------------------
		-- Si il y a des boucliers
	else
		local valdiz = math.floor(val / 1000)
		local valunit = math.floor(val - (1000 * valdiz))
		local shielddiz = math.floor(shield / 1000)
		local shieldunit = math.floor(shield - (1000 * shielddiz))
		local valstring,shieldstring = "",""
		if not(O["short"]) then
			if valdiz == 0 then
				valstring = valunit
			elseif valunit >= 100 then
				valstring = valdiz .. " " .. valunit
			elseif valunit >= 10 then 
				valstring = valdiz .. " 0" .. valunit
			else
				valstring = valdiz .. " 00" .. valunit
			end
			-------
			if shielddiz == 0 then
				shieldstring = shieldunit
			elseif shieldunit >= 100 then
				shieldstring = shielddiz .. " " .. shieldunit
			elseif shieldunit >= 10 then 
				shieldstring = shielddiz .. " 0" .. shieldunit
			else
				shieldstring = shielddiz .. " 00" .. shieldunit
			end
		else
			if valdiz ~= 0 then
				valstring = valdiz .. "k"
			else
				valstring = valunit
			end
			-------
			if shielddiz ~= 0 then
				shieldstring = shielddiz .. "k"
			else
				shieldstring = shieldunit
			end
		end
		
		if DK_SPE then
			ft1DK:SetText(valstring .. " (" .. shieldstring .. ")")
		else
			ft1DK:SetText(valstring .. " / " .. viestring)
		end
		bgDK:Show()
		BfDK:Show()
		if val/vie > 1 then
			BfDK:SetWidth(O["f:largeur"])
		else 
			BfDK:SetWidth((val/vie)*O["f:largeur"])
		end
		BfDK:SetPoint("LEFT",0,0)
	end
end
end








------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------ Fonctions Frames
------------------------------------------------------------------------------------
function Sh_createFrame(nom,parent,hauteur,largeur)
   --Crée une Frame, tout simplement
   ------------------------------------------
   local ff = CreateFrame("Frame",nom,parent)
   ff:SetFrameStrata("MEDIUM")
   ff:SetWidth(largeur)
   ff:SetHeight(hauteur)
   
    
   return ff   
end
------------------------------------------


------------------------------------------
function Sh_createBar()
   -- Crée les frames nécessaires à l'affichage de l'addon
   -----------------------------------------
   -- Conteneur
	bg = CreateFrame("Frame","Sh_bg_container",UIParent)
	bg:SetFrameStrata("MEDIUM")
	bg:SetWidth(O["f:largeur"])
	bg:SetHeight(O["f:hauteur"])
	bg:SetBackdrop({bgFile = O["f:tex:fond"] })
	bg:SetBackdropColor(0,0,0,0)
	bg:SetFrameLevel(O["level"])
	bg:Show()
   
	blink = CreateFrame("Frame","Sh_blink_blink",bg)
	blink:SetFrameStrata("MEDIUM")
	blink:SetAllPoints(bg)
	blink:SetBackdrop({bgFile = "Interface\\Tooltips\\UI-Tooltip-Background" })
	blink:SetFrameLevel(O["level"] + 10)
   
   
   
   -- Frame du fond
	f = CreateFrame("Frame","Sh_f_fond",bg)
	f:SetFrameStrata("MEDIUM")
	f:SetWidth(O["f:largeur"])
	f:SetHeight(O["f:hauteur"])
	f:SetBackdrop({bgFile = O["f:tex:fond"], 
         edgeFile = O["f:tex:border"],
         edgeSize = O["border:size"],
		 insets = {
		 left = O["insets:left"],
		 right = O["insets:right"],
		 top = O["insets:top"],
		 bottom = O["insets:bottom"],
		 },})
	f:SetBackdropColor(O["f:SBC:r"],O["f:SBC:v"],O["f:SBC:b"],O["f:SBC:a"]);
	f:SetPoint("CENTER",0,0)
   -----------------------------------------
   -- Extase
   	raptureFRAME = Sh_createFrame("Sh_raptureFRAME_raptureIcon",bg,O["iconsize"],O["iconsize"])
	raptureFRAME:SetPoint("LEFT",-O["iconsize"] -O["insets:left"],((O["insets:bottom"]-O["insets:top"])/2))
	raptureTEX = raptureFRAME:CreateTexture(nil,"BACKGROUND")
	raptureTEX:SetAllPoints(raptureFRAME)
	raptureTEX:SetTexture("Interface\\Icons\\spell_holy_rapture")
	raptureCD = CreateFrame("Cooldown","raptureFRAMECD",raptureFRAME)
	raptureCD:SetAllPoints(raptureFRAME)
	raptureFRAME:Hide()
	
   -----------------------------------------
   -- Frame des icones
	i1 = Sh_createFrame("Sh_i1_icon1",f,O["iconsize"],O["iconsize"])
	i1:SetPoint("LEFT",O["insets:left"],((O["insets:bottom"]-O["insets:top"])/2))
	i1_tex = i1:CreateTexture(nil,"BACKGROUND")
	i1_tex:SetAllPoints(i1)
	i1_tex:SetTexture("Interface\\Icons\\trade_engineering")
	i1CD = CreateFrame("Cooldown","i1CD",i1)
	i1CD:SetAllPoints(i1)   
   
   
	i2 = Sh_createFrame("Sh_i2_icon2",f,O["iconsize"],O["iconsize"])
	i2:SetPoint("LEFT",O["iconsize"] +O["insets:left"],((O["insets:bottom"]-O["insets:top"])/2))
	i2_tex = i2:CreateTexture(nil,"BACKGROUND")
	i2_tex:SetAllPoints(i2)
	i2_tex:SetTexture("Interface\\Icons\\trade_engineering")
	i2CD = CreateFrame("Cooldown","i2CD",i2)
	i2CD:SetAllPoints(i2)
   
   ----------------------------------  
   -- Frame du fond des barres
   fb = Sh_createFrame("Sh_fb_fondBarres",f,O["f:hauteur"] - (O["insets:top"] + O["insets:bottom"]),O["f:largeur"]-(O["iconsize"]*2 + O["insets:left"]+O["insets:right"]))
   fb:SetFrameStrata("MEDIUM")
   fb:SetPoint("LEFT",O["iconsize"]*2 +O["insets:left"],((O["insets:bottom"]-O["insets:top"])/2))
   fb:Show()
   
   fb2 = Sh_createFrame("Sh_fb2_fondBarreLevel9",f,O["f:hauteur"] -(O["insets:top"] + O["insets:bottom"]),O["f:largeur"]-(O["iconsize"]*2 +O["insets:left"]+O["insets:right"]))
   fb2:SetFrameStrata("MEDIUM")
   fb2:SetPoint("LEFT",O["iconsize"]*2 +O["insets:left"],((O["insets:bottom"]-O["insets:top"])/2))
   fb2:Show()
   fb2:SetFrameLevel(O["level"] + 9)
   
   -----------------------------------------  
   -- Frame de la barre de vie du bouclier
   
   for j=1,9 do
       	Bf[j] = CreateFrame("Frame","Sh_Bf" .. j .. "_Barre",fb)
		Bf[j]:SetFrameStrata("MEDIUM")
		Bf[j]:SetWidth(0)
		Bf[j]:SetHeight(O["f:hauteur"] -(O["insets:top"] + O["insets:bottom"]),0)
		Bf[j]:SetPoint("LEFT",0,0)
		Bf[j]:Show()
		
		Bf_tex[j] = Bf[j]:CreateTexture(nil,"BACKGROUND")
		Bf_tex[j]:SetTexture(O["tex_barre"])
		Bf_tex[j]:SetVertexColor(O[j .. ":r"],O[j .. ":v"],O[j .. ":b"])
		Bf_tex[j]:SetAllPoints(Bf[j])
      
   end
   
   
   -- Texte de la valeur et du pourcentage du bouclier
   ft1 = fb2:CreateFontString("Sh_ft1_texteVal","MEDIUM")
   ft1:SetFont(O["font:val"], O["font:val:size"])
   ft1:SetText("")
   ft1:SetTextColor(O["font:val:r"],O["font:val:v"],O["font:val:b"],O["font:val:a"])
   ft1:SetPoint("CENTER", 0, 0)
   ft1:Show()
   
   
   
   
   
   
   
   ----------------------------------------------------------------------------------------
   
      -- Crée les frames nécessaires à l'affichage de l'addon
   -----------------------------------------
   -- Conteneur
	bgtar = CreateFrame("Frame","Sh_bgtar_container",UIParent)
	bgtar:SetFrameStrata("MEDIUM")
	bgtar:SetWidth(Ot["f:largeur"])
	bgtar:SetHeight(Ot["f:hauteur"])
	bgtar:SetBackdrop({bgFile = Ot["f:tex:fond"] })
	bgtar:SetBackdropColor(0,0,0,0)
	bgtar:SetFrameLevel(Ot["level"])
	bgtar:Show()
   
	blinktar = CreateFrame("Frame","Sh_blinktar_blink",bgtar)
	blinktar:SetFrameStrata("MEDIUM")
	blinktar:SetAllPoints(bgtar)
	blinktar:SetBackdrop({bgFile = "Interface\\Tooltips\\UI-Tooltip-Background"})
	blinktar:SetBackdropColor(1,0,0,0)
	blinktar:SetFrameLevel(Ot["level"] + 10)
   
   
   
   -- Frame du fond
	ftar = CreateFrame("Frame","Sh_ftar_fond",bgtar)
	ftar:SetFrameStrata("MEDIUM")
	ftar:SetWidth(Ot["f:largeur"])
	ftar:SetHeight(Ot["f:hauteur"])
	ftar:SetBackdrop({bgFile = Ot["f:tex:fond"], 
         edgeFile = Ot["f:tex:border"],
         edgeSize = Ot["border:size"],
		 insets = {
		 left = Ot["insets:left"],
		 right = Ot["insets:right"],
		 top = Ot["insets:top"],
		 bottom = Ot["insets:bottom"],
		 },})
	ftar:SetBackdropColor(Ot["f:SBC:r"],Ot["f:SBC:v"],Ot["f:SBC:b"],Ot["f:SBC:a"]);
	ftar:SetPoint("CENTER",0,0)

	
   -----------------------------------------
   -- Frame des icones
	i1tar = Sh_createFrame("Sh_i1tar_icon1",ftar,Ot["iconsize"],Ot["iconsize"])
	i1tar:SetPoint("LEFT",Ot["insets:left"],((Ot["insets:bottom"]-Ot["insets:top"])/2))
	i1_textar = i1tar:CreateTexture(nil,"BACKGROUND")
	i1_textar:SetAllPoints(i1tar)
	i1_textar:SetTexture("Interface\\Icons\\trade_engineering")
	i1CDtar = CreateFrame("Cooldown","i1CDtar",i1tar)
	i1CDtar:SetAllPoints(i1tar)   
   
   
	i2tar = Sh_createFrame("Sh_i2tar_icon2",ftar,Ot["iconsize"],Ot["iconsize"])
	i2tar:SetPoint("LEFT",Ot["iconsize"] +Ot["insets:left"],((Ot["insets:bottom"]-Ot["insets:top"])/2))
	i2_textar = i2tar:CreateTexture(nil,"BACKGROUND")
	i2_textar:SetAllPoints(i2tar)
	i2_textar:SetTexture("Interface\\Icons\\trade_engineering")
	i2CDtar = CreateFrame("Cooldown","i2CDtar",i2tar)
	i2CDtar:SetAllPoints(i2tar)
   
   ----------------------------------  
   -- Frame du fond des barres
   fbtar = Sh_createFrame("Sh_fbtar_fondBarres",ftar,Ot["f:hauteur"] - (Ot["insets:top"]+Ot["insets:bottom"]),Ot["f:largeur"]-(Ot["iconsize"]*2 + Ot["insets:left"]+Ot["insets:right"]))
   fbtar:SetFrameStrata("MEDIUM")
   fbtar:SetPoint("LEFT",Ot["iconsize"]*2 +Ot["insets:left"],((Ot["insets:bottom"]-Ot["insets:top"])/2))
   fbtar:Show()
   
   fb2tar = Sh_createFrame("Sh_fb2tar_fondBarreLevel9",ftar,Ot["f:hauteur"] -(Ot["insets:top"]+Ot["insets:bottom"]),Ot["f:largeur"]-(Ot["iconsize"]*2 +Ot["insets:left"]+Ot["insets:right"]))
   fb2tar:SetFrameStrata("MEDIUM")
   fb2tar:SetPoint("LEFT",Ot["iconsize"]*2 +Ot["insets:left"],((Ot["insets:bottom"]-Ot["insets:top"])/2))
   fb2tar:Show()
   fb2tar:SetFrameLevel(Ot["level"] + 9)
   
   -----------------------------------------  
   -- Frame de la barre de vie du bouclier
   
   for j=1,9 do
       	Bftar[j] = CreateFrame("Frame","Sh_Bftar" .. j .. "_Barre",fbtar)
		Bftar[j]:SetFrameStrata("MEDIUM")
		Bftar[j]:SetWidth(0)
		Bftar[j]:SetHeight(Ot["f:hauteur"] -(Ot["insets:top"]+Ot["insets:bottom"]))
		--Bftar[j]:SetPoint("LEFT",Ot["iconsize"]*2 +Ot["insets:left"],((Ot["insets:bottom"]-Ot["insets:top"])/2))
		Bftar[j]:Show()
		
		Bf_textar[j] = Bftar[j]:CreateTexture(nil,"BACKGROUND")
		Bf_textar[j]:SetTexture(Ot["tex_barre"])
		Bf_textar[j]:SetVertexColor(Ot[j .. ":r"],Ot[j .. ":v"],Ot[j .. ":b"])
		Bf_textar[j]:SetAllPoints(Bftar[j])
      
   end
   
   
   -- Texte de la valeur et du pourcentage du bouclier
   ft1tar = fb2tar:CreateFontString("Sh_ft1tar_texteVal","MEDIUM")
   ft1tar:SetFont(Ot["font:val"], Ot["font:val:size"])
   ft1tar:SetText("")
   ft1tar:SetTextColor(Ot["font:val:r"],Ot["font:val:v"],Ot["font:val:b"],Ot["font:val:a"])
   ft1tar:SetPoint("CENTER", 0, 0)
   ft1tar:Show()
   
   
  ------------------------ FRAME DK 
   
	bgDK = CreateFrame("Frame","Sh_bgDK_container",UIParent)
	bgDK:SetFrameStrata("MEDIUM")
	bgDK:SetWidth(O["f:largeur"])
	bgDK:SetHeight(O["f:hauteur"])
	bgDK:SetBackdrop({bgFile = O["f:tex:fond"] })
	bgDK:SetBackdropColor(1,1,1,1)
	bgDK:SetFrameLevel(O["level"])
	bgDK:Hide()
   
   
   
   -- Frame du fond
	fDK = CreateFrame("Frame","Sh_fDK_fond",bgDK)
	fDK:SetFrameStrata("MEDIUM")
	fDK:SetWidth(O["f:largeur"])
	fDK:SetHeight(O["f:hauteur"])
	fDK:SetBackdrop({bgFile = O["f:tex:fond"], 
         edgeFile = O["f:tex:border"],
         edgeSize = O["border:size"],
		 insets = {
		 left = O["insets:left"],
		 right = O["insets:right"],
		 top = O["insets:top"],
		 bottom = O["insets:bottom"],
		 },})
	fDK:SetBackdropColor(O["f:SBC:r"],O["f:SBC:v"],O["f:SBC:b"],O["f:SBC:a"]);
	fDK:SetPoint("CENTER",0,0)

   
   ----------------------------------  
   -- Frame du fond des barres
   fbDK = Sh_createFrame("Sh_fbDK_fondBarres",fDK,O["f:hauteur"] - (O["insets:top"] + O["insets:bottom"]),O["f:largeur"]-(O["iconsize"]*2 + O["insets:left"]+O["insets:right"]))
   fbDK:SetFrameStrata("MEDIUM")
   fbDK:SetPoint("LEFT",O["iconsize"]*2 +O["insets:left"],((O["insets:bottom"]-O["insets:top"])/2))
   fbDK:Show()
   
   fb2DK = Sh_createFrame("Sh_fb2DK_fondBarreLevel9",fDK,O["f:hauteur"] -(O["insets:top"] + O["insets:bottom"]),O["f:largeur"]-(O["iconsize"]*2 +O["insets:left"]+O["insets:right"]))
   fb2DK:SetFrameStrata("MEDIUM")
   fb2DK:SetPoint("LEFT",O["iconsize"]*2 +O["insets:left"],((O["insets:bottom"]-O["insets:top"])/2))
   fb2DK:Show()
   fb2DK:SetFrameLevel(O["level"] + 9)
   
   -----------------------------------------  
   -- Frame de la barre de vie du bouclier
   

	BfDK = CreateFrame("Frame","Sh_BfDK",fbDK)
	BfDK:SetFrameStrata("MEDIUM")
	BfDK:SetWidth(0)
	BfDK:SetHeight(O["f:hauteur"] -(O["insets:top"] + O["insets:bottom"]),0)
	BfDK:SetPoint("LEFT",0,0)
	BfDK:Show()
	
	Bf_texDK = BfDK:CreateTexture(nil,"BACKGROUND")
	Bf_texDK:SetTexture(O["tex_barre"])
	Bf_texDK:SetVertexColor(O[1 .. ":r"],O[1 .. ":v"],O[1 .. ":b"])
	Bf_texDK:SetAllPoints(BfDK)
   
   
   -- Texte de la valeur et du pourcentage du bouclier
   ft1DK = fb2DK:CreateFontString("Sh_ft1_texteValDK","MEDIUM")
   ft1DK:SetFont(O["font:val"], O["font:val:size"])
   ft1DK:SetText("")
   ft1DK:SetTextColor(O["font:val:r"],O["font:val:v"],O["font:val:b"],O["font:val:a"])
   ft1DK:SetPoint("CENTER", 0, 0)
   ft1DK:Show()
end





function Sh_refresh()
	
	if cb[5]:GetChecked() then O["contour"] = true else O["contour"] = false end
	if cb[25]:GetChecked() then Ot["contour"] = true else Ot["contour"] = false end
	if cb[35]:GetChecked() then Odk["contour"] = true else Odk["contour"] = false end
	
	O["enable"] = cb[1]:GetChecked()
	Oo["enable_extase"] = cb[2]:GetChecked()
	if O["enable"] then bg:Show() else bg:Hide() end
	O["short"] = cb[3]:GetChecked()


	bg:SetPoint(O["f:pos:1"],O["f:pos:2"],O["f:pos:3"],O["f:pos:4"],O["f:pos:5"])
	bg:SetWidth(O["f:largeur"])
	bg:SetHeight(O["f:hauteur"])
	bg:SetFrameLevel(O["level"])

	f:SetWidth(O["f:largeur"])
	f:SetHeight(O["f:hauteur"])
	f:SetBackdrop({bgFile = O["f:tex:fond"], 
		edgeFile = O["f:tex:border"],
		edgeSize = O["border:size"],
		insets = {
		left = O["insets:left"],
		right = O["insets:right"],
		top = O["insets:top"],
		bottom = O["insets:bottom"],
		},})
	f:SetBackdropColor(O["f:SBC:r"],O["f:SBC:v"],O["f:SBC:b"],O["f:SBC:a"])
   
   
	raptureFRAME:SetWidth(O["iconsize"])
	raptureFRAME:SetHeight(O["iconsize"])
	i1:SetWidth(O["iconsize"])
	i1:SetHeight(O["iconsize"])
	i1:SetPoint("LEFT",O["insets:left"],((O["insets:bottom"]-O["insets:top"])/2))
	i2:SetWidth(O["iconsize"])
	i2:SetHeight(O["iconsize"])
	i2:SetPoint("LEFT",O["iconsize"] +O["insets:left"],((O["insets:bottom"]-O["insets:top"])/2))

	fb:SetWidth(O["f:largeur"]-(O["iconsize"]*2 +O["insets:left"]+O["insets:right"]))
	fb:SetPoint("LEFT",(O["iconsize"]*2 +O["insets:left"]),((O["insets:bottom"]-O["insets:top"])/2))
	fb2:SetWidth(O["f:largeur"]-(O["iconsize"]*2 +O["insets:left"]+O["insets:right"]))
	fb2:SetPoint("LEFT",(O["iconsize"]*2 +O["insets:left"]),((O["insets:bottom"]-O["insets:top"])/2))



	ft1:SetTextColor(O["font:val:r"],O["font:val:v"],O["font:val:b"],O["font:val:a"])
	if O["contour"] then outline = "OUTLINE" else outline = nil end
	ft1:SetFont(O["font:val"], O["font:val:size"],outline)


   
   
   
	--------------------------------------------------------------------------------
   
   
	Ot["enable"] = cb[21]:GetChecked()
	if Ot["enable"] then bgtar:Show() else bgtar:Hide() end
	Ot["short"] = cb[23]:GetChecked()

	bgtar:SetPoint(Ot["f:pos:1"],Ot["f:pos:2"],Ot["f:pos:3"],Ot["f:pos:4"],Ot["f:pos:5"])
	bgtar:SetWidth(Ot["f:largeur"])
	bgtar:SetHeight(Ot["f:hauteur"])
	bgtar:SetFrameLevel(Ot["level"])

	ftar:SetWidth(Ot["f:largeur"])
	ftar:SetHeight(Ot["f:hauteur"])
	ftar:SetBackdrop({bgFile = Ot["f:tex:fond"], 
		edgeFile = Ot["f:tex:border"],
		edgeSize = Ot["border:size"],
		insets = {
		left = Ot["insets:left"],
		right = Ot["insets:right"],
		top = Ot["insets:top"],
		bottom = Ot["insets:bottom"],
		},})
	ftar:SetBackdropColor(Ot["f:SBC:r"],Ot["f:SBC:v"],Ot["f:SBC:b"],Ot["f:SBC:a"])



	i1tar:SetWidth(Ot["iconsize"])
	i1tar:SetHeight(Ot["iconsize"])
	i1tar:SetPoint("LEFT",Ot["insets:left"],((Ot["insets:bottom"]-Ot["insets:top"])/2))
	i2tar:SetWidth(Ot["iconsize"])
	i2tar:SetHeight(Ot["iconsize"])
	i2tar:SetPoint("LEFT",Ot["iconsize"] +Ot["insets:left"],((Ot["insets:bottom"]-Ot["insets:top"])/2))

	fbtar:SetWidth(Ot["f:largeur"]-(Ot["iconsize"]*2 +Ot["insets:left"]+Ot["insets:right"]))
	fbtar:SetPoint("LEFT",(Ot["iconsize"]*2 +Ot["insets:left"]),((Ot["insets:bottom"]-Ot["insets:top"])/2))
	fb2tar:SetWidth(Ot["f:largeur"]-(Ot["iconsize"]*2 +Ot["insets:left"]+Ot["insets:right"]))
	fb2tar:SetPoint("LEFT",(Ot["iconsize"]*2 +Ot["insets:left"]),((Ot["insets:bottom"]-Ot["insets:top"])/2))

	
	ft1tar:SetTextColor(Ot["font:val:r"],Ot["font:val:v"],Ot["font:val:b"],Ot["font:val:a"])
	if Ot["contour"] then outline = "OUTLINE" else outline = nil end
	ft1tar:SetFont(Ot["font:val"], Ot["font:val:size"], outline)

	for j=1,9 do
		Bf_tex[j]:SetTexture(O["tex_barre"])
		Bf_tex[j]:SetVertexColor(O[j .. ":r"],O[j .. ":v"],O[j .. ":b"],(O["b:a"]/100))

		--Bf[j]:SetPoint("LEFT",O["iconsize"]*2 +O["insets:left"],((O["insets:bottom"]-O["insets:top"])/2))
		Bf[j]:SetHeight(O["f:hauteur"] -(O["insets:top"]+O["insets:bottom"]))

		Bf_textar[j]:SetTexture(Ot["tex_barre"])
		Bf_textar[j]:SetVertexColor(Ot[j .. ":r"],Ot[j .. ":v"],Ot[j .. ":b"],(Ot["b:a"]/100))

		--Bftar[j]:SetPoint("LEFT",Ot["iconsize"]*2 +Ot["insets:left"],((Ot["insets:bottom"]-Ot["insets:top"])/2))
		Bftar[j]:SetHeight(Ot["f:hauteur"] -(Ot["insets:top"]+Ot["insets:bottom"]))
		
		
		
		color_tex[j]:SetTexture(O["tex_barre"])
		color_tex[j+20]:SetTexture(Ot["tex_barre"])
		
		if O["contour"] then outline = "OUTLINE" else outline = nil end
		color_text[j]:SetFont(O["font:val"],12,outline)
		color_text[j]:SetTextColor(O["font:val:r"],O["font:val:v"],O["font:val:b"],O["font:val:a"])
		
		if Ot["contour"] then outline = "OUTLINE" else outline = nil end
		color_text[j+20]:SetFont(Ot["font:val"],12,outline)
		color_text[j+20]:SetTextColor(Ot["font:val:r"],Ot["font:val:v"],Ot["font:val:b"],Ot["font:val:a"])
	end
	
	Bf_texDK:SetTexture(Odk["tex_barre"])
	Bf_texDK:SetVertexColor(Odk["1:r"],Odk["1:v"],Odk["1:b"],(Odk["b:a"]/100))

	BfDK:SetHeight(Odk["f:hauteur"] -(Odk["insets:top"]+Odk["insets:bottom"]))

	color_tex[41]:SetTexture(Odk["tex_barre"])
	if Odk["contour"] then outline = "OUTLINE" else outline = nil end
	color_text[41]:SetFont(Odk["font:val"],12,outline)
	color_text[41]:SetTextColor(Odk["font:val:r"],Odk["font:val:v"],Odk["font:val:b"],Odk["font:val:a"])
	------- DK
	
	bgDK:SetPoint("CENTER",0,0)
	bgDK:SetWidth(O["f:largeur"])
	bgDK:SetHeight(O["f:hauteur"])
	bgDK:SetFrameLevel(O["level"])

	fDK:SetWidth(O["f:largeur"])
	fDK:SetHeight(O["f:hauteur"])
	fDK:SetBackdrop({bgFile = O["f:tex:fond"], 
		edgeFile = O["f:tex:border"],
		edgeSize = O["border:size"],
		insets = {
		left = O["insets:left"],
		right = O["insets:right"],
		top = O["insets:top"],
		bottom = O["insets:bottom"],
		},})
	fDK:SetBackdropColor(O["f:SBC:r"],O["f:SBC:v"],O["f:SBC:b"],O["f:SBC:a"])
   
   


	fbDK:SetWidth(O["f:largeur"]-(O["insets:left"]+O["insets:right"]))
	fbDK:SetPoint("LEFT",(O["insets:left"]),((O["insets:bottom"]-O["insets:top"])/2))
	fb2DK:SetWidth(O["f:largeur"]-(O["insets:left"]+O["insets:right"]))
	fb2DK:SetPoint("LEFT",(O["insets:left"]),((O["insets:bottom"]-O["insets:top"])/2))



	ft1DK:SetTextColor(O["font:val:r"],O["font:val:v"],O["font:val:b"],O["font:val:a"])
	if O["contour"] then outline = "OUTLINE" else outline = nil end
	ft1DK:SetFont(O["font:val"], O["font:val:size"],outline)
	
	
	
	-------- Refresh ColorPicker
		
	color_fontval_tex[1]:SetVertexColor(O["font:val:r"],O["font:val:v"],O["font:val:b"],O["font:val:a"])
	
	color_fontval_tex[2]:SetTexture(O["f:tex:fond"])
	color_fontval_tex[2]:SetVertexColor(O["f:SBC:r"],O["f:SBC:v"],O["f:SBC:b"],O["f:SBC:a"])
			
			
	color_fontval_tex[21]:SetVertexColor(Ot["font:val:r"],Ot["font:val:v"],Ot["font:val:b"],Ot["font:val:a"])
	
	color_fontval_tex[22]:SetTexture(Ot["f:tex:fond"])
	color_fontval_tex[22]:SetVertexColor(Ot["f:SBC:r"],Ot["f:SBC:v"],Ot["f:SBC:b"],Ot["f:SBC:a"])
	
	
    color_fontval_tex[41]:SetVertexColor(Odk["font:val:r"],Odk["font:val:v"],Odk["font:val:b"],Odk["font:val:a"])
	
	color_fontval_tex[42]:SetTexture(Odk["f:tex:fond"])
	color_fontval_tex[42]:SetVertexColor(Odk["f:SBC:r"],Odk["f:SBC:v"],Odk["f:SBC:b"],Odk["f:SBC:a"])
	
	
	-- Refresh ordre :
	for i,j in pairs(Oo["Ord"]) do
		ordre[j]:SetPoint("LEFT",20,135-(30*i))
		toggle_ordre[j]:SetChecked(Oo["Ord:toggle"][j])
	end
	
	
	-- Checkbox
	O["blink"] = cb[4]:GetChecked()
	Ot["blink"] = cb[24]:GetChecked()
	
	
   	Sh_test()
	Sh_OnEvent()
end



function Sh_refresh_options()
--------- Refresh des options
	local function slider_refresh(nb,var)
	slider[nb]:SetValue(var)
	getglobal(slider[nb]:GetName() .. 'Text'):SetText(var)
	end
	slider_refresh(1,O["b:a"])
	slider_refresh(2,O["font:val:size"])
	slider_refresh(3,O["f:largeur"])
	slider_refresh(4,O["f:hauteur"])
	slider_refresh(5,O["border:size"])
	slider_refresh(6,O["iconsize"])
	slider_refresh(7,O["level"])
	
	slider_refresh(21,Ot["b:a"])
	slider_refresh(22,Ot["font:val:size"])
	slider_refresh(23,Ot["f:largeur"])
	slider_refresh(24,Ot["f:hauteur"])
	slider_refresh(25,Ot["border:size"])
	slider_refresh(26,Ot["iconsize"])
	slider_refresh(27,Ot["level"])

	
	slider_refresh(10,O["insets:left"])
	slider_refresh(11,O["insets:right"])
	slider_refresh(12,O["insets:top"])
	slider_refresh(13,O["insets:bottom"])
	
	slider_refresh(30,Ot["insets:left"])
	slider_refresh(31,Ot["insets:right"])
	slider_refresh(32,Ot["insets:top"])
	slider_refresh(33,Ot["insets:bottom"])
	
	slider_refresh(50,Odk["insets:left"])
	slider_refresh(51,Odk["insets:right"])
	slider_refresh(52,Odk["insets:top"])
	slider_refresh(53,Odk["insets:bottom"])
	
	-- Checkbox
	cb[5]:SetChecked(O["contour"])
	cb[25]:SetChecked(Ot["contour"])
	cb[35]:SetChecked(Odk["contour"])
	
	cb[4]:SetChecked(O["blink"])
	cb[24]:SetChecked(Ot["blink"])
	
	-- DropDownMenu
	local function DDM_set(nb,item,var,type)
		local idcheck = 1
		for j=1,table.getn(item) do
			if O[var] == LSM:Fetch(type,item[j]) and nb<20 then
				idcheck = j
			elseif Ot[var] == LSM:Fetch(type,item[j]) and nb>20 then
				idcheck = j
			elseif Odk[var] == LSM:Fetch(type,item[j]) and nb>40 then
				idcheck = j
			end
		end
		
		UIDropDownMenu_SetSelectedValue(Sh_DDM[nb], idcheck)
	end
	
	DDM_set(1,M_statusbar,"tex_barre","statusbar")
	DDM_set(2,M_font,"font:val","font")
	DDM_set(3,M_border,"f:tex:border","border")
	DDM_set(4,M_background,"f:tex:fond","background")

	DDM_set(21,M_statusbar,"tex_barre","statusbar")
	DDM_set(22,M_font,"font:val","font")
	DDM_set(23,M_border,"f:tex:border","border")
	DDM_set(24,M_background,"f:tex:fond","background")
	
	DDM_set(41,M_statusbar,"tex_barre","statusbar")
	DDM_set(42,M_font,"font:val","font")
	DDM_set(43,M_border,"f:tex:border","border")
	DDM_set(44,M_background,"f:tex:fond","background")
	
	----------
	for j=1,9 do
		--color_tex[j]:SetVertexColor(O[j .. ":r"],O[j .. ":v"],O[j .. ":b"])
		--color_tex[j+20]:SetVertexColor(Ot[j .. ":r"],Ot[j .. ":v"],Ot[j .. ":b"])
		
		ordre[j]:SetBackdropColor(O[j .. ":r"],O[j .. ":v"],O[j .. ":b"],0.2)
	
		color_tex[j]:SetVertexColor(O[j .. ":r"],O[j .. ":v"],O[j .. ":b"])
		color_tex[j+20]:SetVertexColor(Ot[j .. ":r"],Ot[j .. ":v"],Ot[j .. ":b"])
		color_tex[41]:SetVertexColor(Odk["1:r"],Odk["1:v"],Odk["1:b"])
		
		Bf_textar[j]:SetTexture(Ot["tex_barre"])
		Bf_textar[j]:SetVertexColor(Ot[j .. ":r"],Ot[j .. ":v"],Ot[j .. ":b"],(Ot["b:a"]/100))

		Bftar[j]:SetPoint("LEFT",Ot["iconsize"]*2 +Ot["insets:left"],((Ot["insets:bottom"]-Ot["insets:top"])/2))
		Bftar[j]:SetHeight(Ot["f:hauteur"] -(Ot["insets:top"]+Ot["insets:bottom"]))

		
		Bf_tex[j]:SetTexture(O["tex_barre"])
		Bf_tex[j]:SetVertexColor(O[j .. ":r"],O[j .. ":v"],O[j .. ":b"],(O["b:a"]/100))
	  
		Bf[j]:SetPoint("LEFT",O["iconsize"]*2 +O["insets:left"],((O["insets:bottom"]-O["insets:top"])/2))
		Bf[j]:SetHeight(O["f:hauteur"] -(O["insets:top"]+O["insets:bottom"]))
		
		
		Bf_texDK:SetTexture(Odk["tex_barre"])
		Bf_texDK:SetVertexColor(Odk[j .. ":r"],Odk[j .. ":v"],Odk[j .. ":b"],(Odk["b:a"]/100))
	  
		BfDK:SetPoint("LEFT",Odk["insets:left"],((Odk["insets:bottom"]-Odk["insets:top"])/2))
		BfDK:SetHeight(Odk["f:hauteur"] -(Odk["insets:top"]+Odk["insets:bottom"]))
	
	end
	
	Sh_profile_createlist()
end

function Sh_refresh_cp()
	for j=1,9 do
		color_tex[j]:SetVertexColor(O[j .. ":r"],O[j .. ":v"],O[j .. ":b"])
		color_tex[j+20]:SetVertexColor(Ot[j .. ":r"],Ot[j .. ":v"],Ot[j .. ":b"])
		color_text[j]:SetTextColor(O["font:val:r"],O["font:val:v"],O["font:val:b"],O["font:val:a"])
		color_text[j+40]:SetTextColor(O["font:val:r"],O["font:val:v"],O["font:val:b"],O["font:val:a"])		


		Bf_textar[j]:SetVertexColor(Ot[j .. ":r"],Ot[j .. ":v"],Ot[j .. ":b"],(Ot["b:a"]/100))
		Bf_tex[j]:SetVertexColor(O[j .. ":r"],O[j .. ":v"],O[j .. ":b"],(O["b:a"]/100))
	end
	color_tex[41]:SetVertexColor(Odk["1:r"],Odk["1:v"],Odk["1:b"])
	color_text[41]:SetTextColor(Odk["font:val:r"],Odk["font:val:v"],Odk["font:val:b"],Odk["font:val:a"])
	
	
	color_fontval_tex[1]:SetVertexColor(O["font:val:r"],O["font:val:v"],O["font:val:b"],O["font:val:a"])
	color_fontval_tex[2]:SetVertexColor(O["f:SBC:r"],O["f:SBC:v"],O["f:SBC:b"],O["f:SBC:a"])
			
	color_fontval_tex[21]:SetVertexColor(Ot["font:val:r"],Ot["font:val:v"],Ot["font:val:b"],Ot["font:val:a"])
	color_fontval_tex[22]:SetVertexColor(Ot["f:SBC:r"],Ot["f:SBC:v"],Ot["f:SBC:b"],Ot["f:SBC:a"])
	
    color_fontval_tex[41]:SetVertexColor(Odk["font:val:r"],Odk["font:val:v"],Odk["font:val:b"],Odk["font:val:a"])
	color_fontval_tex[42]:SetVertexColor(Odk["f:SBC:r"],Odk["f:SBC:v"],Odk["f:SBC:b"],Odk["f:SBC:a"])
	
	f:SetBackdropColor(O["f:SBC:r"],O["f:SBC:v"],O["f:SBC:b"],O["f:SBC:a"])
	ft1:SetTextColor(O["font:val:r"],O["font:val:v"],O["font:val:b"],O["font:val:a"])
	
	ftar:SetBackdropColor(Ot["f:SBC:r"],Ot["f:SBC:v"],Ot["f:SBC:b"],Ot["f:SBC:a"])
	ft1tar:SetTextColor(Ot["font:val:r"],Ot["font:val:v"],Ot["font:val:b"],Ot["font:val:a"])
	
	fDK:SetBackdropColor(O["f:SBC:r"],O["f:SBC:v"],O["f:SBC:b"],O["f:SBC:a"])	
	ft1DK:SetTextColor(O["font:val:r"],O["font:val:v"],O["font:val:b"],O["font:val:a"])
	

end






























------------------------------------------------------------------------------------
------------------------------------------ OPTION LOAD

function Sh_opt_LOAD()
	if not(Sh_DB) then
		Sh_DB = {}
		Sh_DB["Profile"] = {}
		Sh_DB["Profile"][NAME .. "-" .. REALM] = "Default"
		PROFILE = "Default"
		
		Sh_DB["Default"] = {}
		Sh_DB["Default"]["nb"] = 1
		Sh_DB["Default"]["O"] = Sh_deep(O)
		Sh_DB["Default"]["Ot"] = Sh_deep(Ot)
		Sh_DB["Default"]["Odk"] = Sh_deep(Odk)
		Sh_DB["Default"]["Oo"] = Sh_deep(Oo)
	end
	
	
	
	
	local x1 = true
	if Sh_DB["Profile"][NAME .. "-" .. REALM] == nil or Sh_DB[Sh_DB["Profile"][NAME .. "-" .. REALM]] == nil then
		PROFILE = "Default"
		Sh_DB["Profile"][NAME .. "-" .. REALM] = "Default"
		if Sh_DB[PROFILE] == nil then
			Sh_DB["Default"] = {}
			Sh_DB["Default"]["nb"] = 1
			Sh_DB["Default"]["O"] = Sh_deep(O)
			Sh_DB["Default"]["Ot"] = Sh_deep(Ot)
			Sh_DB["Default"]["Odk"] = Sh_deep(Odk)
			Sh_DB["Default"]["Oo"] = Sh_deep(Oo)
		end
		else
		PROFILE = Sh_DB["Profile"][NAME .. "-" .. REALM]
	end
	
	O = Sh_deep(Sh_DB[PROFILE]["O"])
	Ot = Sh_deep(Sh_DB[PROFILE]["Ot"])
	Odk = Sh_deep(Sh_DB[PROFILE]["Odk"])
	Oo = Sh_deep(Sh_DB[PROFILE]["Oo"])

	if Sh_DB[PROFILE]["version"] ~= nil then
		if Sh_DB[PROFILE]["version"] >= VERSION then
			x1 = false
		end
	end
	
	
	if x1 then
		if Sh_DB["Profile"]["version"] then
			Sh_print("ShieldHealth has been updated : |cff00ff00v" .. Sh_DB["Profile"]["version"] .. "|r ==> |cff00ff00v" .. VERSION .. "|r !")
		else
			Sh_print("ShieldHealth has been installed : |cff00ff00v" .. VERSION .. "|r !")
		end
		Sh_DB["Profile"]["version"] = VERSION
		Sh_DB[PROFILE]["version"] = VERSION
	end

	Sh_opt()
	Sh_refresh()
	
end






function Sh_opt_OK()
   Sh_DB[PROFILE]["O"] = Sh_deep(O)
   Sh_DB[PROFILE]["Ot"] = Sh_deep(Ot)
   Sh_DB[PROFILE]["Odk"] = Sh_deep(Odk)
   Sh_DB[PROFILE]["Oo"] = Sh_deep(Oo)
end










------------------------------------------------------------------------------------




function Sh_EventFrame_OnEvent(self, event, ...)
   Sh_OnEvent()
end

function Sh_EventFrame3_OnEvent(self,event,...)
	if event == "COMBAT_LOG_EVENT_UNFILTERED" then
	if CLASS == "DEATHKNIGHT" and Odk["enable"] then
		local x1,x2 = 0,false
		local _,Type,x4,x5,x6,x7,x8,x9,Target,x11,x12,Val13,Val14,x15,Val16,Val17,x18,x19,x20,Val21 = select(1, ...)
		
local val = 0
for i,k in pairs(DAMAGE) do
	val = k + val
end
local vie = (0.07 * UnitHealthMax("player"))
val = (0.2 * val * DK_TALENT)

if vie > val then
	val = vie
end
local shield = DK_MASTERY * val
val = math.floor(val)
shield = math.floor(shield)

		if Type == "SPELL_HEAL" and Val14 == "Frappe de mort" then
			print("HEAL : " .. Val16 .. " / " .. val)
		end
		if Type == "SPELL_AURA_APPLIED" and Val14 == "Bouclier de sang" then
			print("BOUBOU : " .. Val17 .. " / " .. shield)
		end
		--print(...)
		
		if Target == NAME then
			if Type == "SWING_DAMAGE" then
				x1 = Val13
				x2 = true
			elseif Type == "SWING_MISSED" then
				if Val13 == "ABSORB" then
					x1 = Val14
					x2 = true
				end
			elseif (Type == "SPELL_DAMAGE" or Type == "SPELL_PERIODIC_DAMAGE" or Type == "RANGE_DAMAGE") then
				x1 = Val16
				x2 = true
			elseif (Type == "SPELL_MISSED" or Type == "SPELL_PERIODIC_MISSED" or Type == "RANGE_MISSED") then
				if Val16 == "ABSORB" then
					x1 = Val17
					x2 = true
				end
			elseif Type == "DAMAGE_SHIELD" then
				if Val16 == 0 then
					x1 = Val21
				else
					x1 = Val16
				end
				x2 = true
			end
			if x1 == nil then
				x1 = 0
			end
			if x2 then
				DAMAGE[DMG] = DAMAGE[DMG] + x1
				Sh_DK_update()
			end
		end
	end

	if Oo["enable_extase"] then
		if select(12, ...) == 47755 and select(6, ...) == NAME then
			raptureFRAME:Show()
			raptureTIME = GetTime()
			raptureCD:SetCooldown(raptureTIME,12)
		end
	end

	if string.sub(select(2, ...),1,11) == "SPELL_AURA_" and select(17, ...) then
		local _,Type,_,_,_,_,_,_,Target,_,_,SpellID,_,_,_,Val = select(1, ...)
		local x1,x2 = false,0
		for j=1,9 do
			if SpellID == Bid[j] then x1 = true; x2 = j; break; end
		end
		if x1 then
			local s = Sh_tar_slot(Target)
			
			if Type == "SPELL_AURA_APPLIES" then
				slot[s][x2] = Val
				slot[s][11] = Target
			elseif Type == "SPELL_AURA_REFRESH" then
				if slot[s][x2] < Val then
					slot[s][x2] = Val
					slot[s][11] = Target
				end
			elseif Type == "SPELL_AURA_REMOVED" then
				slot[s][x2] = Val
				slot[s][11] = Target
			end
		end
	end 
	end
end















------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
-------------------------------------]]--[[-----------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------ MENU DANS INTERFACE>ADDONS
function Sh_opt_menu()
   -- Crée le menu des options
   ------------------------------------------
	ShieldHealth = {};
	ShieldHealth.panel = CreateFrame( "Frame", "ShieldHealthPanel", UIParent);
	ShieldHealth.panel.name = "Shield Health";
	InterfaceOptions_AddCategory(ShieldHealth.panel);
	ShieldHealth.panel.okay = function ()  Sh_opt_OK() end
	ShieldHealth.panel.cancel = function () Sh_opt_OK() end
	ShieldHealth.panel.default = function ()  Sh_opt_OK() end



	ShieldHealth.childpanel_player = CreateFrame( "Frame", "ShieldHealthChildPlayer", ShieldHealth.panel);
	ShieldHealth.childpanel_player.name = L["Joueur"];
	ShieldHealth.childpanel_player.parent = ShieldHealth.panel.name;
	InterfaceOptions_AddCategory(ShieldHealth.childpanel_player);
	
	ShieldHealth.childpanel_target = CreateFrame( "Frame", "ShieldHealthChildTarget", ShieldHealth.panel);
	ShieldHealth.childpanel_target.name = L["Cible"];
	ShieldHealth.childpanel_target.parent = ShieldHealth.panel.name;
	InterfaceOptions_AddCategory(ShieldHealth.childpanel_target);
	
	ShieldHealth.childpanel_dk = CreateFrame( "Frame", "ShieldHealthChildDK", ShieldHealth.panel);
	ShieldHealth.childpanel_dk.name = L["dk"];
	ShieldHealth.childpanel_dk.parent = ShieldHealth.panel.name;
	InterfaceOptions_AddCategory(ShieldHealth.childpanel_dk);
	
	local dklolz = CreateFrame( "Frame", "DKLOLZ", ShieldHealth.childpanel_dk);
	dklolz:SetAllPoints(ShieldHealth.childpanel_dk)
	dklolz:SetFrameStrata("HIGH")
	dklolz:SetFrameLevel(20)
	dklolz:SetBackdrop({
         bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", 
         edgeFile = "empty",
	})
	dklolz:SetBackdropColor(0,0,0,0.4)
	dklolz:EnableMouse(true)
	dklolz:Show()

   
	local dklolztext = dklolz:CreateFontString("texteOption","MEDIUM","GameFontNormal")
	dklolztext:SetText("This is disabled beacause I hate DeathKnights.")
	dklolztext:SetTextHeight(15)
	dklolztext:SetTextColor(1,0,0,1)
	dklolztext:SetPoint("CENTER", dklolz, 20, -5)
	dklolztext:Show()
	
	ShieldHealth.childpanel_ordre = CreateFrame( "Frame", "ShieldHealthChildOrdre", ShieldHealth.panel);
	ShieldHealth.childpanel_ordre.name = L["Ordre"];
	ShieldHealth.childpanel_ordre.parent = ShieldHealth.panel.name;
	InterfaceOptions_AddCategory(ShieldHealth.childpanel_ordre);
end


------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------ SLIDER
function Sh_opt_createSlider(nb,nom,parent,val,min,max,var,lock,unit)
   -- Règle les options du slider
   ------------------------------------------
   slider[nb] = CreateFrame("Slider", nom, parent, "OptionsSliderTemplate")
   slider[nb]:ClearAllPoints()
   slider[nb]:SetMinMaxValues(min,max)
   slider[nb]:SetValue(val)
   slider[nb]:SetWidth(125)
   getglobal(slider[nb]:GetName() .. 'Low'):SetText(min);
   getglobal(slider[nb]:GetName() .. 'High'):SetText(max);
   getglobal(slider[nb]:GetName() .. 'Text'):SetText(val);   
   slider[nb]:SetValueStep(1)
   slider[nb]:Show()
   
   
   slidermoins[nb] = CreateFrame("Button", "btn-_" .. nom, slider[nb], "UIPanelButtonTemplate2")
   slidermoins[nb]:SetPoint("LEFT", -33, 0)
   slidermoins[nb]:SetText("-")
   slidermoins[nb]:SetScript("OnClick",function() slider[nb]:SetValue(slider[nb]:GetValue()-1) Sh_opt_sliderUpdate(nb,var,unit) end)
   slidermoins[nb]:SetWidth (17)
   slidermoins[nb]:Show()
   
   sliderplus[nb] = CreateFrame("Button", "btn+_" .. nom, slider[nb], "UIPanelButtonTemplate2")
   sliderplus[nb]:SetPoint("LEFT", -19, 0)
   sliderplus[nb]:SetText("+")
   sliderplus[nb]:SetScript("OnClick",function() slider[nb]:SetValue(slider[nb]:GetValue()+1) Sh_opt_sliderUpdate(nb,var,unit) end)
   sliderplus[nb]:SetWidth(17)
   sliderplus[nb]:Show()
   
   -- met à jour la valeur au dessus su slider
   slider[nb]:SetScript("OnValueChanged", function() Sh_opt_sliderUpdate(nb,var,unit) end)
   
   -- permet de 'dévérouiller' le slider
   if not(lock) then
      slider[nb]:SetScript("OnMouseUp",  function() Sh_opt_sliderVal(nb) end)
   end
   
end

function Sh_opt_sliderUpdate(nb,var,unit)
	local sliderval =  math.ceil(slider[nb]:GetValue())
	getglobal(slider[nb]:GetName() .. 'Text'):SetText(sliderval)
	if unit == "target" then
		Ot[var] = sliderval
	elseif unit == "player" then
		O[var] = sliderval
	else
		Odk[var] = sliderval
	end
	Sh_refresh() 
end

function Sh_opt_sliderVal(nb)
   local slideval =  math.ceil(slider[nb]:GetValue())
   slider[nb]:SetMinMaxValues(slideval-100,slideval+100)
   slider[nb]:SetValue(slideval)
   getglobal(slider[nb]:GetName() .. 'Low'):SetText(slideval-100)
   getglobal(slider[nb]:GetName() .. 'High'):SetText(slideval+100)
end

------------------------------------------
function Sh_opt_Slider(slider,val,min,max)
   -- retourne la valeur de slider ou le met aux valeurs précisés
   ------------------------------------------
   if val then
      slider:SetMinMaxValues(min,max)
      slider:SetValue(val)
      getglobal(slider:GetName() .. 'Low'):SetText(min)
      getglobal(slider:GetName() .. 'High'):SetText(max)
      Slider:SetValueStep(1)
   else 
      return  math.ceil(slider:GetValue())
   end
end

------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------ CHECKBOX
function Sh_opt_createCheckbox(nom,texte,parent)
   -- règles les options de la checkbox
   ------------------------------------------
   local cbtemp = CreateFrame("CheckButton", nom, parent, "UICheckButtonTemplate")
   cbtemp:ClearAllPoints()
   _G[nom .. "Text"]:SetText(texte)
   _G[nom .. "Text"]:SetTextColor(1,1,1,1)
   cbtemp:SetScript("OnClick", function()
			Sh_refresh()
		end
   )
   
   
   return cbtemp
end


------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------ DROP DOWN MENU
function Sh_opt_createDDM(nom,parent,largeur,items,var,type,unit)
   -- Crée un Drop Down menu
   ------------------------------------------
   	Sh_DDM_items[nom] = items
	Sh_DDM_var[nom] = var
	Sh_DDM_type[nom] = type
	Sh_DDM_tar[nom] = unit
	
	Sh_DDM[nom] = CreateFrame("Frame", "DDM" .. nom, parent, "UIDropDownMenuTemplate")
   
	Sh_DDM[nom]:ClearAllPoints()
	Sh_DDM[nom]:Show()
	
	
	
	UIDropDownMenu_Initialize(Sh_DDM[nom], function(self,level) Sh_opt_DDMinitialize(self,level,items,type,var,nom,unit) end)
	UIDropDownMenu_SetWidth(Sh_DDM[nom], largeur);
	UIDropDownMenu_SetButtonWidth(Sh_DDM[nom], 124)
	UIDropDownMenu_JustifyText(Sh_DDM[nom], "LEFT")
	
	local idcheck = 1
	for j=1,table.getn(items) do
		if Ot[var] == LSM:Fetch(type,items[j]) and unit == "target" then
			idcheck = j
			break
		elseif O[var] == LSM:Fetch(type,items[j]) and unit == "player" then
			idcheck = j
			break
		elseif Odk[var] == LSM:Fetch(type,items[j]) then
			idcheck = j
			break
		end
	end
	if table.getn(items) > 20 then
		if idcheck < 20 then
			idcheck = idcheck - 1
		end
	end
	--UIDropDownMenu_SetSelectedValue(Sh_DDM[nom], idcheck)
   
end

function Sh_opt_DDMinitialize(self, level, item, type, var, nom, unit)
	local info = UIDropDownMenu_CreateInfo()
	local i = 1
	
	local idcheck = 1
	for j=1,table.getn(item) do
		if Ot[var] == LSM:Fetch(type,item[j]) and unit == "target" then
			idcheck = j
			break
		elseif O[var] == LSM:Fetch(type,item[j]) and unit == "player" then
			idcheck = j
			break
		elseif Odk[var] == LSM:Fetch(type,item[j]) then
			idcheck = j
			break
		end
	end
	if table.getn(item) > 20 then
		if idcheck < 20 then
			idcheck = idcheck - 1
		end
	end

	
	if table.getn(item) > 20 and level == 1 then
		info = UIDropDownMenu_CreateInfo()
		info.hasArrow = true; 
		info.notCheckable = true;
		info.text = L["plus"]
		UIDropDownMenu_AddButton(info, 1)
	end

	for k, v in pairs(item) do
		
		if i <= 20 and level == 1 then
			info = UIDropDownMenu_CreateInfo()
			info.text = v
			info.value = i
			info.func = function(self) Sh_opt_DDMOnClick(self,0,item,type,var,nom,unit) end
			UIDropDownMenu_AddButton(info, 1)
		elseif i > 20 and level == 2 then
			info = UIDropDownMenu_CreateInfo()
			info.text = v
			info.value = i
			info.func = function(self) Sh_opt_DDMOnClick(self,1,item,type,var,nom,unit) end
			UIDropDownMenu_AddButton(info, 2)
		end
		
		if idcheck == i then
			UIDropDownMenu_SetSelectedValue(self, i)
		end

		i = i + 1
	end
end

function Sh_opt_DDMOnClick(self,x1,item,type,var,nom,unit)
	
	local ID = self:GetID()
	if x1 == 1 then
		ID = ID + 20
	elseif table.getn(item) > 20 then
		ID = ID - 1
	end
	UIDropDownMenu_SetSelectedValue(Sh_DDM[nom], ID)
	
	-----------
	if unit == "target" then
		Ot[var] = LSM:Fetch(type,item[ID])
	elseif unit == "player" then
		O[var] = LSM:Fetch(type,item[ID])
	else
		Odk[var] = LSM:Fetch(type,item[ID])
	end
	Sh_refresh()
	-----------
end


	
------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------ COLOR PICKER

------------------------------------------
function Sh_opt_showCP(r, v, b, a, Sh_opt_CPCallback,n,unit)
   -- Appel le ColorPicker puis la fonction de CallBack
   ------------------------------------------ 
   ColorPickerFrame:SetColorRGB(r,v,b);
   ColorPickerFrame.hasOpacity, ColorPickerFrame.opacity = (a ~= nil), a;
   ColorPickerFrame.previousValues = {r,v,b,a};
   ColorPickerFrame.func, ColorPickerFrame.opacityFunc, ColorPickerFrame.cancelFunc = 
   function() Sh_opt_CPCallback(false,tostring(n),unit) end, Sh_opt_CPCallbackOK, Sh_opt_CPCallback;
   ColorPickerFrame:Hide();
   ColorPickerFrame:Show();
end

------------------------------------------
function Sh_opt_CPCallback(restore,var,unit)
   -- Fonction de CallBack du ColorPicker
   ------------------------------------------
	local newR, newV, newB, newA;
	if restore then
		newR, newV, newB, newA = unpack(restore);
	else
		newA, newR, newV, newB = OpacitySliderFrame:GetValue(), ColorPickerFrame:GetColorRGB();
	end


	if unit == "target" then
		Ot[var .. ":r"], Ot[var .. ":v"], Ot[var .. ":b"], Ot[var .. ":a"] = newR, newV, newB, newA
	elseif unit == "player" then
		O[var .. ":r"], O[var .. ":v"], O[var .. ":b"], O[var .. ":a"] = newR, newV, newB, newA
	else
		Odk["1:r"], Odk["1:v"], Odk["1:b"], Odk["1:a"] = newR, newV, newB, newA
	end
	--------- Refresh des couleurs des CP des options

	Sh_refresh_cp()	

end


function Sh_opt_CPCallbackOK()
	Sh_refresh_options()
	Sh_refresh()
end

------------------------------------------
function Sh_opt_createCP(nb,texte,parent,r,v,b,a)
	-- Fonction de création d'un carré de couleur qui appel le CP
	------------------------------------------
	cp[nb] = CreateFrame("Frame","ColorPickerFrame",parent)
	cp[nb]:SetFrameStrata("HIGH")
	cp[nb]:SetWidth(45)
	cp[nb]:SetHeight(18)


	local text = cp[nb]:CreateFontString("ColorPickerText","MEDIUM","GameFontNormal")
	text:SetText(texte)
	text:SetTextHeight(12)
	text:SetTextColor(1,1,1,1)
	text:SetPoint("RIGHT", cp[nb], -55, 0)
	text:Show()
end


function Sh_opt_texte(texte,taille,parent,r,v,b)
	local text = parent:CreateFontString("TexteOption","MEDIUM","GameFontNormal")
	text:SetText(texte)
	text:SetTextHeight(taille)
	text:SetTextColor(r,v,b,1)
	text:Show()
	return text  
end
   
   
   
   
   
function Sh_opt()
   Sh_opt_menu()
   
   ------------------------------------------------------------------------------------
   ------------------------------------------  CREATION DU MENU
   ------------------------------------------------------------------------------------
      
   ------------------------------------------------------------------------------------
   ------------------------------------------------------------------------------------
   ------------------------------------------ OPTIONS
   ------------------------------------------------------------------------------------
   ------------------------------------------------------------------------------------
	
	

	
	
	
   
   	
   -----------------------------------------------
   
	local function Sh_Tooltip_OnEnter(self,titre,ligne1,ligne2)
		GameTooltip:SetOwner(self, "ANCHOR_CURSOR")
		if titre then GameTooltip:SetText(titre) end
		if ligne1 then GameTooltip:AddLine(ligne1, 1, 1, 1) end
		if ligne2 then GameTooltip:AddLine(ligne2, 1, 1, 1) end
		GameTooltip:Show()
	end
	local function Sh_Tooltip_OnLeave(self)
		GameTooltip:Hide()
	end

   
   	btn[41] = CreateFrame("Button", "btn41", ShieldHealth.panel, "UIPanelButtonTemplate2")
	btn[41]:SetPoint("LEFT",10,0)
	btn[41]:SetText(L["Deverouiller"])
	btn[41]:SetScript("OnClick",function() btn[44]:Show(); Sh_opt_moveframe(true) end)
	btn[41]:SetWidth (110)
	btn[41]:Show()
   
   	btn[42] = CreateFrame("Button", "btn42", ShieldHealth.panel, "UIPanelButtonTemplate2")
	btn[42]:SetPoint("LEFT",120,0)
	btn[42]:SetText(L["test"])
	btn[42]:SetScript("OnClick",function() if TESTMODE then TESTMODE = false; Sh_OnEvent() else TESTMODE = true; Sh_test() end end)
	btn[42]:SetWidth (110)
	btn[42]:Show()
	
   
	btn[44] = CreateFrame("Button", "btn44", UIParent, "UIPanelButtonTemplate2")
	btn[44]:SetPoint("CENTER",0,50)
	btn[44]:SetText(L["Verouiller"])
	btn[44]:SetWidth (110)
	btn[44]:SetScript("OnClick",function() btn[44]:Hide(); Sh_opt_moveframe(false) end)
	btn[44]:Hide()

   function Sh_opt_moveframe(bool)
		if bool then
			bg:RegisterForDrag("LeftButton")
			bg:SetMovable(true) 
			bg:EnableMouse(true)
			bg:SetScript("OnDragStart", function() bg:StartMoving() end)
			bg:SetScript("OnDragStop", function() bg:StopMovingOrSizing() O["f:pos:1"],O["f:pos:2"],O["f:pos:3"],O["f:pos:4"],O["f:pos:5"] = bg:GetPoint() Ot["f:pos:1"],Ot["f:pos:2"],Ot["f:pos:3"],Ot["f:pos:4"],Ot["f:pos:5"] = bgtar:GetPoint() end)
			bg:SetFrameLevel(O["level"]+50)
			 
			bgtar:RegisterForDrag("LeftButton")
			bgtar:SetMovable(true) 
			bgtar:EnableMouse(true)
			bgtar:SetScript("OnDragStart", function() bgtar:StartMoving() end)
			bgtar:SetScript("OnDragStop", function() bgtar:StopMovingOrSizing() O["f:pos:1"],O["f:pos:2"],O["f:pos:3"],O["f:pos:4"],O["f:pos:5"] = bgtar:GetPoint() Ot["f:pos:1"],Ot["f:pos:2"],Ot["f:pos:3"],Ot["f:pos:4"],Ot["f:pos:5"] = bgtar:GetPoint() end)
			bgtar:SetFrameLevel(Ot["level"]+50)
			
			bgDK:RegisterForDrag("LeftButton")
			bgDK:SetMovable(true) 
			bgDK:EnableMouse(true)
			bgDK:SetScript("OnDragStart", function() bgDK:StartMoving() end)
			bgDK:SetScript("OnDragStop", function() bgDK:StopMovingOrSizing() O["f:pos:1"],O["f:pos:2"],O["f:pos:3"],O["f:pos:4"],O["f:pos:5"] = bgDK:GetPoint() Odk["f:pos:1"],Odk["f:pos:2"],Odk["f:pos:3"],Odk["f:pos:4"],Odk["f:pos:5"] = bgDK:GetPoint() end)
			bgDK:SetFrameLevel(Odk["level"]+50)
        else
			bg:SetMovable(false)
			bg:EnableMouse(false)
			O["f:pos:1"],O["f:pos:2"],O["f:pos:3"],O["f:pos:4"],O["f:pos:5"] = bg:GetPoint()
			Sh_DB[PROFILE]["O"]["f:pos:1"],Sh_DB[PROFILE]["O"]["f:pos:2"],Sh_DB[PROFILE]["O"]["f:pos:3"],Sh_DB[PROFILE]["O"]["f:pos:4"],Sh_DB[PROFILE]["O"]["f:pos:5"] = O["f:pos:1"],O["f:pos:2"],O["f:pos:3"],O["f:pos:4"],O["f:pos:5"]
			bg:SetFrameLevel(O["level"])

			bgtar:SetMovable(false)
			bgtar:EnableMouse(false)
			Ot["f:pos:1"],Ot["f:pos:2"],Ot["f:pos:3"],Ot["f:pos:4"],Ot["f:pos:5"] = bgtar:GetPoint()
			Sh_DB[PROFILE]["Ot"]["f:pos:1"],Sh_DB[PROFILE]["Ot"]["f:pos:2"],Sh_DB[PROFILE]["Ot"]["f:pos:3"],Sh_DB[PROFILE]["Ot"]["f:pos:4"],Sh_DB[PROFILE]["Ot"]["f:pos:5"] = Ot["f:pos:1"],Ot["f:pos:2"],Ot["f:pos:3"],Ot["f:pos:4"],Ot["f:pos:5"]
			bgtar:SetFrameLevel(Ot["level"])
			
			bgDK:SetMovable(false)
			bgDK:EnableMouse(false)
			Odk["f:pos:1"],Odk["f:pos:2"],Odk["f:pos:3"],Odk["f:pos:4"],Odk["f:pos:5"] = bgtar:GetPoint()
			Sh_DB[PROFILE]["Odk"]["f:pos:1"],Sh_DB[PROFILE]["Odk"]["f:pos:2"],Sh_DB[PROFILE]["Odk"]["f:pos:3"],Sh_DB[PROFILE]["Odk"]["f:pos:4"],Sh_DB[PROFILE]["Odk"]["f:pos:5"] = Odk["f:pos:1"],Odk["f:pos:2"],Odk["f:pos:3"],Odk["f:pos:4"],Odk["f:pos:5"]
			bgDK:SetFrameLevel(Odk["level"])
		end
	end
   
   
   
   
	--------------------------	--------------------------
	---------------------  PROFILE  ----------------------
	--------------------------	--------------------------
	
	
	local Shield_profile = CreateFrame("frame", "Shield_profile", ShieldHealth.panel)
	Shield_profile:SetFrameStrata("HIGH")
	Shield_profile:SetBackdrop({
		  bgFile = "empty", 
		  edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		  edgeSize = 11,
	})
	Shield_profile:SetBackdropColor(1,0,0,0)
	Shield_profile:SetPoint("TOPLEFT",ShieldHealth.panel,"TOPLEFT",5,-5)
	Shield_profile:SetPoint("BOTTOMRIGHT",ShieldHealth.panel,"RIGHT",-5,25)
	Shield_profile:Show()


	local text_Shield_profile = Shield_profile:CreateFontString("texteOption","MEDIUM","GameFontNormal")
	text_Shield_profile:SetText(L["Profile"])
	text_Shield_profile:SetTextHeight(15)
	text_Shield_profile:SetTextColor(0.8,0.8,0,1)
	text_Shield_profile:SetPoint("TOPLEFT", Shield_profile, 20, -5)
	text_Shield_profile:Show()
	

	
	local sf = CreateFrame("ScrollFrame", "Sh_SF_Profile", Shield_profile, "UIPanelScrollFrameTemplate");
	sf:SetPoint("TOPLEFT",Shield_profile,"TOPLEFT",10,-30)
	sf:SetPoint("BOTTOMRIGHT",Shield_profile,"BOTTOM",0,10)
	sf:SetBackdrop({
		bgFile = "empty", 
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		edgeSize = 13,
	})

	local ccf = CreateFrame("Frame", "Sh_CF_Profile", sf);
	ccf:SetSize(300, 25*(table.getn(Sh_DB)+1));
	ccf:SetPoint("TOPLEFT");

	sf:SetScrollChild(ccf);

	local profile_list = {}
	local profile_selected

	function Sh_profile_createlist(nchange)
		profile_list = {}
		for k, v in pairs(Sh_DB) do
			if k ~= "Profile" then 
				if k == PROFILE then
					PROFILENB = Sh_DB[k]["nb"]
				end
				profile_list[Sh_DB[k]["nb"]] = k
			end
		end
		profile_selected = PROFILENB
		
		ccf:SetSize(300, 25*(table.getn(Sh_DB)+1));
		
		if nchange then
			for k,v in pairs(Profile_SF_frame) do
				if Profile_SF_frame[k] ~= nil then
					Profile_SF_frame[k]:Hide()
				end
			end
		end
		
		local x1 = 1
		for i, k in pairs(profile_list) do
			if Profile_SF_frame[i] == nil then
				Profile_SF_frame[i] = CreateFrame("frame", "Profile_list_frame" .. i, ccf)
				Profile_SF_frame[i]:SetWidth(ccf:GetWidth())
				Profile_SF_frame[i]:SetHeight(25)
				Profile_SF_frame[i]:SetBackdrop({
				bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", 
				edgeFile = "empty",
				})
				Profile_SF_frame[i]:SetPoint("TOPLEFT", 2.5, -((i-x1)*25));

				Profile_SF_text[i] = Profile_SF_frame[i]:CreateFontString("Profile_list_text" .. i,"MEDIUM","GameFontNormal")
				Profile_SF_text[i]:SetTextHeight(14)
				Profile_SF_text[i]:SetPoint("LEFT", Profile_SF_frame[i], 5, 0)
				Profile_SF_text[i]:Show()
			end
			Profile_SF_frame[i]:SetBackdropColor(1,1,1,0)
			Profile_SF_frame[i]:Show()
			
			Profile_SF_text[i]:SetText(i .. "." .. k)
			if k == PROFILE then
				Profile_SF_text[i]:SetTextColor(1,1,0,1)
			else
				Profile_SF_text[i]:SetTextColor(1,1,1,1)
			end
			
			Profile_SF_frame[i]:SetScript("OnMouseDown",function(self)
					Profile_SF_frame[profile_selected]:SetBackdropColor(1,1,1,0)
					profile_selected = i
					self:SetBackdropColor(1,1,1,0.5)
				end
				)
			Profile_SF_frame[i]:SetScript("OnEnter",function(self) if profile_selected ~= i then self:SetBackdropColor(1,1,1,0.1) end end)
			Profile_SF_frame[i]:SetScript("OnLeave",function(self) if profile_selected ~= i then self:SetBackdropColor(1,1,1,0) end end)
		end
		Profile_SF_frame[PROFILENB]:SetBackdropColor(1,1,1,0.5)
	end
	Sh_profile_createlist()
	----------------------------
	------------- POPUP
	----------------------------
	
	StaticPopupDialogs["SH_RENAME"] = {
		text = L["Profile_Popup_rename"],
		button1 = ACCEPT,
		button2 = CANCEL,
		OnHide = function(self)

		end,
		hasEditBox = 1,
		maxLetters = 15,
		OnAccept = function(self)
			local text = self.editBox:GetText();
			Sh_profile_rename(text)
		end,
		EditBoxOnEnterPressed = function(self)
			local text = self:GetParent().editBox:GetText();
			Sh_profile_rename(text)
			self:GetParent():Hide();
		end,
		timeout = 0,
		hideOnEscape = 1
	};
	
	
	StaticPopupDialogs["SH_SAVEAS"] = {
		text = L["Profile_Popup_saveas"],
		button1 = ACCEPT,
		button2 = CANCEL,
		OnHide = function(self)

		end,
		hasEditBox = 1,
		maxLetters = 25,
		OnAccept = function(self)
			local text = self.editBox:GetText();
			Sh_profile_saveas(text)
		end,
		EditBoxOnEnterPressed = function(self)
			local text = self:GetParent().editBox:GetText();
			Sh_profile_saveas(text)
			self:GetParent():Hide();
		end,
		timeout = 0,
		hideOnEscape = 1
	};

	
	StaticPopupDialogs["SH_NEW"] = {
		text = L["Profile_Popup_new"],
		button1 = ACCEPT,
		button2 = CANCEL,
		OnHide = function(self)

		end,
		hasEditBox = 1,
		maxLetters = 25,
		OnAccept = function(self)
			local text = self.editBox:GetText();
			Sh_profile_new(text)
		end,
		EditBoxOnEnterPressed = function(self)
			local text = self:GetParent().editBox:GetText();
			Sh_profile_new(text)
			self:GetParent():Hide();
		end,
		timeout = 0,
		hideOnEscape = 1
	};	
	
	StaticPopupDialogs["SH_RESET"] = {
		text = L["Profile_Popup_reset"],
		button1 = ACCEPT,
		button2 = CANCEL,
		OnHide = function(self)

		end,
		hasEditBox = 0,
		OnAccept = Sh_reset,
		alert = 1,
		timeout = 0,
		hideOnEscape = 1
	};	
	-------------------------
	
	function Sh_profile_appliquer()
		Sh_DB[PROFILE]["O"] = Sh_deep(O)
		Sh_DB[PROFILE]["Ot"] = Sh_deep(Ot)
		Sh_DB[PROFILE]["Odk"] = Sh_deep(Odk)
		Sh_DB[PROFILE]["Oo"] = Sh_deep(Oo)
		
		Profile_SF_text[PROFILENB]:SetTextColor(1,1,1,1)
		
		PROFILE = profile_list[profile_selected]
		Sh_DB["Profile"][NAME .. "-" .. REALM] = PROFILE
		PROFILENB = profile_selected
		
		O = Sh_deep(Sh_DB[PROFILE]["O"])
		Ot = Sh_deep(Sh_DB[PROFILE]["Ot"])
		Odk = Sh_deep(Sh_DB[PROFILE]["Odk"])
		Oo = Sh_deep(Sh_DB[PROFILE]["Oo"])
		
		Profile_SF_text[profile_selected]:SetTextColor(1,1,0,1)
		
		Sh_refresh_options()
		Sh_refresh()
		Sh_profile_createlist()
	end
	
	function Sh_profile_rename(text)
		if text ~= nil and text ~= "Profile" and text ~= "" then
			local xcheck = true
			for k,v in pairs(Sh_DB) do
				if text == k then
					xcheck = false
					break
				end
			end
			
			if xcheck then
				Sh_DB[text] = Sh_deep(Sh_DB[profile_list[profile_selected]])
				Sh_DB[profile_list[profile_selected]] = nil
				if PROFILE == profile_list[profile_selected] then
					PROFILE = text
					local x1 = 1
					for k,v in pairs(Sh_DB) do
						if PROFILE == k then
							PROFILENB = x1			
						end
					end
					x1 = nil
				end
				
				Sh_profile_createlist()
			end
		end
	end
	
	function Sh_profile_saveas(text)
		if text ~= nil and text ~= "Profile" and text ~= "" then
			local xcheck = true
			for k,v in pairs(Sh_DB) do
				if text == k then
					xcheck = false
					break
				end
			end
			
			if xcheck then
				local x1 = {}
				local i = 1
				for k,v in pairs(Sh_DB) do
					if k ~= "Profile" then
						x1[i] = Sh_DB[k]["nb"]
						i = i + 1
					end
				end
				i = nil
				table.sort(x1)
				for i=1,(table.getn(x1)+1) do
					if x1[i] ~= i then
						x1 = i
						break
					end
				end
				Sh_DB[text] = Sh_deep(Sh_DB[profile_list[profile_selected]])
				Sh_DB[text]["nb"] = x1
				ccf:SetHeight(ccf:GetHeight()+25)
				Sh_profile_createlist()
			end
		end
	end
	
	function Sh_profile_new(text)
		if text ~= nil and text ~= "Profile" and text ~= "" then
			local x1 = {}
			local i = 1
			for k,v in pairs(Sh_DB) do
				if k ~= "Profile" then
					x1[i] = Sh_DB[k]["nb"]
					i = i + 1
				end
			end
			i = nil
			table.sort(x1)
			for i=1,(table.getn(x1)+1) do
				if x1[i] ~= i then
					x1 = i
					break
				end
			end
			print(x1)
			Sh_DB[text] = {}
			
			Sh_DB[text]["nb"] = x1
			Sh_DB[text]["O"] = Sh_deep(O)
			Sh_DB[text]["Ot"] = Sh_deep(Ot)
			Sh_DB[text]["Odk"] = Sh_deep(Odk)
			Sh_DB[text]["Oo"] = Sh_deep(Oo)
			
			Sh_profile_createlist()
		end
	end
	
	function Sh_profile_delete()
		if profile_list[profile_selected] ~= PROFILE then
			for k,v in pairs(Sh_DB) do
				if k ~= "Profile" then
					if Sh_DB[k]["nb"] > Sh_DB[profile_list[profile_selected]]["nb"] then
						Sh_DB[k]["nb"] = Sh_DB[k]["nb"] - 1
					end
				end
			end
			Sh_DB[profile_list[profile_selected]] = nil
			
			profile_selected = PROFILENB
			Sh_profile_createlist(true)
		end
	end
	
	-------------------------
	-------------------------
	btn[50] = CreateFrame("Button", "btn50", sf, "UIPanelButtonTemplate2")
	btn[50]:SetPoint("LEFT",sf,"RIGHT",25,60)
	btn[50]:SetText(L["Profile_appliquer"])
	btn[50]:SetWidth (100)
	btn[50]:SetScript("OnClick",function()
			Sh_profile_appliquer()
		end
	)
	btn[50]:Show()
	
	
	btn[51] = CreateFrame("Button", "btn51", sf, "UIPanelButtonTemplate2")
	btn[51]:SetPoint("LEFT",sf,"RIGHT",25,30)
	btn[51]:SetText(L["Profile_rename"])
	btn[51]:SetWidth (100)
	btn[51]:SetScript("OnClick",function()
			StaticPopup_Show("SH_RENAME")
		end
	)
	btn[51]:Show()
	
	
	btn[52] = CreateFrame("Button", "btn52", sf, "UIPanelButtonTemplate2")
	btn[52]:SetPoint("LEFT",sf,"RIGHT",25,0)
	btn[52]:SetText(L["Profile_saveas"])
	btn[52]:SetWidth (100)
	btn[52]:SetScript("OnClick",function()
			StaticPopup_Show("SH_SAVEAS")
		end
	)
	btn[52]:Show()
	
	
	btn[53] = CreateFrame("Button", "btn53", sf, "UIPanelButtonTemplate2")
	btn[53]:SetPoint("LEFT",sf,"RIGHT",25,-30)
	btn[53]:SetText(L["Profile_nouveau"])
	btn[53]:SetWidth (100)
	btn[53]:SetScript("OnClick",function()
			StaticPopup_Show("SH_NEW")
		end
	)
	btn[53]:Show()
	
	
	btn[54] = CreateFrame("Button", "btn54", sf, "UIPanelButtonTemplate2")
	btn[54]:SetPoint("LEFT",sf,"RIGHT",25,-60)
	btn[54]:SetText(L["Profile_delete"])
	btn[54]:SetWidth (100)
	btn[54]:SetScript("OnClick",function()
			Sh_profile_delete()
		end
	)
	btn[54]:Show()
	
	
	btn[55] = CreateFrame("Button", "btn" .. 55, sf, "UIPanelButtonTemplate2")
	btn[55]:SetPoint("LEFT",sf,"RIGHT",25,-90)
	btn[55]:SetText(L["reset"])
	btn[55]:SetScript("OnEnter",function(self) Sh_Tooltip_OnEnter(self,L["reset"],L["reset1"],L["reset2"]) end)
	btn[55]:SetScript("OnLeave",Sh_Tooltip_OnLeave)
	btn[55]:SetScript("OnClick",function() StaticPopup_Show("SH_RESET") end)
	btn[55]:SetWidth(100)
	btn[55]:Show()
	
	
	btn[56] = CreateFrame("Button", "btn" .. 56, Shield_profile, "UIPanelButtonTemplate2")
	btn[56]:SetPoint("LEFT",Shield_profile,"BOTTOMLEFT",0,0)
	btn[56]:SetPoint("RIGHT",Shield_profile,"BOTTOM",0,0)
	btn[56]:SetText(L["targettoplayer"])
	btn[56]:SetScript("OnClick",function() 
			local x1 = Oo["enable_extase"]
			local x2 = O["f:pos:1"]
			local x3 = O["f:pos:2"]
			local x4 = O["f:pos:3"]
			local x5 = O["f:pos:4"]
			local x6 = O["f:pos:5"] 
			local x7 = O["tex_barre"]
			local x8 = O["f:tex:fond"]
			local x9 = O["f:tex:border"]
			local x10 = O["font:val"]


			O = Sh_deep(Ot)
			
			Oo["enable_extase"] = x1
			O["f:pos:1"] = x2
			O["f:pos:2"] = x3
			O["f:pos:3"] = x4
			O["f:pos:4"] = x5
			O["f:pos:5"] = x6
			O["tex_barre"] = x7
			O["f:tex:fond"] = x8
			O["f:tex:border"] = x9
			O["font:val"] = x10
			
			
			Sh_refresh()
			Sh_opt_sliderVal(3)
			Sh_refresh_options()
			Sh_refresh()
			Sh_opt_sliderVal(3)

			
			Sh_opt_OK()
		end
	) 
	btn[56]:Show()
	
	btn[57] = CreateFrame("Button", "btn" .. 57, Shield_profile, "UIPanelButtonTemplate2")
	btn[57]:SetPoint("LEFT",Shield_profile,"BOTTOM",0,0)
	btn[57]:SetPoint("RIGHT",Shield_profile,"BOTTOMRIGHT",0,0)
	btn[57]:SetText(L["playertotarget"])
	btn[57]:SetScript("OnClick",function() 

			local x2 = Ot["f:pos:1"]
			local x3 = Ot["f:pos:2"]
			local x4 = Ot["f:pos:3"]
			local x5 = Ot["f:pos:4"]
			local x6 = Ot["f:pos:5"] 
			local x7 = Ot["tex_barre"]
			local x8 = Ot["f:tex:fond"]
			local x9 = Ot["f:tex:border"]
			local x10 = Ot["font:val"]

			
			Ot = Sh_deep(O)
			
			Ot["enable_extase"] = nil
			Ot["f:pos:1"] = x2
			Ot["f:pos:2"] = x3
			Ot["f:pos:3"] = x4
			Ot["f:pos:4"] = x5
			Ot["f:pos:5"] = x6
			Ot["tex_barre"] = x7
			Ot["f:tex:fond"] = x8
			Ot["f:tex:border"] = x9
			Ot["font:val"] = x10
			
			Sh_refresh()
			Sh_opt_sliderVal(23)
			Sh_refresh_options()
			Sh_refresh()
			Sh_opt_sliderVal(23)
			
			Sh_opt_OK()
		end
	) 
	btn[57]:Show()
	
   ------------------------------------------------------------------------------------
   ------------------------------------------------------------------------------------
   ------------------------------------------ PLAYER
   ------------------------------------------------------------------------------------
   ------------------------------------------------------------------------------------	
   ------------------------------------------ COULEUR DES BARRES

	function Sh_lol(var,parent,color_,slider_,ddm_,cp_,cb_,unit)

			local Shield_color = CreateFrame("frame", "Shield_color", parent)
			Shield_color:SetFrameStrata("HIGH")
			Shield_color:SetBackdrop({
				bgFile = "empty", 
				edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
				edgeSize = 11,
			});
			Shield_color:SetBackdropColor(1,0,0,0)
			Shield_color:Show()
			local text_Shield_color = Shield_color:CreateFontString("textecarre","MEDIUM","GameFontNormal")
			text_Shield_color:SetText(L["Couleur_des_Boucliers"])
			text_Shield_color:SetTextHeight(15)
			text_Shield_color:SetTextColor(0.8,0.8,0,1)
			text_Shield_color:SetPoint("TOPLEFT", Shield_color, 20, 0)
			text_Shield_color:Show()
			
		if unit~= "dk" then
			Shield_color:SetPoint("TOPLEFT",parent,"TOP",0,-5)
			Shield_color:SetPoint("BOTTOMRIGHT",parent,"RIGHT",-5,-50)

			local x1 = 160

			for j=1,9 do
				x1 = x1 - 30
				color[j+color_] = CreateFrame("Frame","ColorPickerFrame" .. j+color_,Shield_color)
				color[j+color_]:SetFrameStrata("HIGH")
				color[j+color_]:SetHeight(18)

				color_text[j+color_] = color[j+color_]:CreateFontString("ColorPickerText" .. j+color_,"MEDIUM","GameFontNormal")
				color_text[j+color_]:SetText(B[j])
				color_text[j+color_]:SetTextHeight(12)
				color_text[j+color_]:SetTextColor(1,1,1,1)
				color_text[j+color_]:SetPoint("LEFT", color[j+color_], 10, 0)
				color_text[j+color_]:Show()

				
				
				
				color[j+color_]:SetPoint("LEFT",20,x1)
				color[j+color_]:SetPoint("RIGHT",-20,x1)
				color[j+color_]:SetScript("OnMouseDown", function() Sh_opt_showCP(var[j .. ":r"], var[j .. ":v"], var[j ..":b"],nil,Sh_opt_CPCallback,j,unit) end)
						
				color_tex[j+color_] = color[j+color_]:CreateTexture(nil,"BACKGROUND")
				color_tex[j+color_]:SetTexture(var["tex_barre"])
				color_tex[j+color_]:SetVertexColor(var[j .. ":r"],var[j .. ":v"],var[j .. ":b"])
				color_tex[j+color_]:SetAllPoints(color[j+color_])
			  
			end

			Sh_opt_createSlider(slider_,"Slider" .. slider_, Shield_color, var["b:a"], 0, 100, "b:a", true, unit)
			slider[slider_]:SetPoint("CENTER", Shield_color,"CENTER",60,-143)

			local text_color_Shield1 = Sh_opt_texte(L["Transparence"], 12,Shield_color,1,1,1)
			text_color_Shield1:SetPoint("LEFT", Shield_color, 20, -143)
			
		else
			
			Shield_color:SetPoint("TOPLEFT",parent,"TOP",0,-5)
			Shield_color:SetPoint("BOTTOMRIGHT",parent,"TOPRIGHT",-5,-100)

			color[1+color_] = CreateFrame("Frame","ColorPickerFrame" .. 41,Shield_color)
			color[1+color_]:SetFrameStrata("HIGH")
			color[1+color_]:SetHeight(18)

			color_text[1+color_] = color[1+color_]:CreateFontString("ColorPickerText" .. 41,"MEDIUM","GameFontNormal")
			color_text[1+color_]:SetText(L["dk_color_text"])
			color_text[1+color_]:SetTextHeight(12)
			color_text[1+color_]:SetTextColor(1,1,1,1)
			color_text[1+color_]:SetPoint("LEFT", color[1+color_], 10, 0)
			color_text[1+color_]:Show()

			
			
			
			color[1+color_]:SetPoint("LEFT",20,10)
			color[1+color_]:SetPoint("RIGHT",-20,10)
			color[1+color_]:SetScript("OnMouseDown", function() Sh_opt_showCP(var[1 .. ":r"], var[1 .. ":v"], var[1 ..":b"],nil,Sh_opt_CPCallback,1,true) end)
					
			color_tex[1+color_] = color[1+color_]:CreateTexture(nil,"BACKGROUND")
			color_tex[1+color_]:SetTexture(var["tex_barre"])
			color_tex[1+color_]:SetVertexColor(var[1 .. ":r"],var[1 .. ":v"],var[1 .. ":b"])
			color_tex[1+color_]:SetAllPoints(color[1+color_])
			  

			Sh_opt_createSlider(slider_,"Slider" .. slider_, Shield_color, var["b:a"], 0, 100, "b:a", true, unit)
			slider[slider_]:SetPoint("CENTER", Shield_color,"CENTER",60,-23)

			local text_color_Shield1 = Sh_opt_texte(L["Transparence"], 12,Shield_color,1,1,1)
			text_color_Shield1:SetPoint("LEFT", Shield_color, 20, -23)
		end
		------------------------------------------------------------------------------------
		------------------------------------------ TEXTURE ET FONT DES BARRE
		local Shield_tex = CreateFrame("frame", "Shield_tex", parent)
		Shield_tex:SetFrameStrata("HIGH")
		Shield_tex:SetBackdrop({
			 bgFile = "empty", 
			 edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
			 edgeSize = 11,
		});
		Shield_tex:SetBackdropColor(1,0,0,0)
		Shield_tex:SetPoint("TOPLEFT",parent,"TOPLEFT",5,-5)
		Shield_tex:SetPoint("BOTTOMRIGHT",parent,"BOTTOM",0,5)
		Shield_tex:Show()

		local Shield_tex_hr = CreateFrame("frame", "Shield_tex_hr", Shield_tex)
		Shield_tex_hr:SetFrameStrata("HIGH")
		Shield_tex_hr:SetBackdrop({
			 bgFile = "empty", 
			 edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
			 edgeSize = 11,
		});
		Shield_tex_hr:SetBackdropColor(1,0,0,1)
		Shield_tex_hr:SetPoint("TOPLEFT",Shield_tex,"TOPLEFT",0,0)
		Shield_tex_hr:SetPoint("BOTTOMRIGHT",Shield_tex,"TOPRIGHT",0,-210)
		Shield_tex_hr:Show()




		--------------------
		local text_Shield_tex = Sh_opt_texte(L["Apparence_barre_boucliers"], 15,Shield_tex,0.8,0.8,0)
		text_Shield_tex:SetPoint("LEFT", Shield_tex, 10, 260)


		----------
		local text_Shield_tex2 = Sh_opt_texte(L["Texture_barre_boucliers"], 12,Shield_tex,1,1,1)
		text_Shield_tex2:SetPoint("LEFT", Shield_tex, 20, 240)


		Sh_opt_createDDM(ddm_, Shield_tex, 240, M_statusbar, "tex_barre", "statusbar",unit)
		Sh_DDM[ddm_]:SetPoint("LEFT", 0, 220)

		----------
		local text_Shield_tex3 = Sh_opt_texte(L["Police_vie_boucliers"], 12,Shield_tex,1,1,1)
		text_Shield_tex3:SetPoint("LEFT", Shield_tex, 20, 195)

		ddm_=ddm_+1 --2
		Sh_opt_createDDM(ddm_, Shield_tex, 240, M_font, "font:val", "font",unit)
		Sh_DDM[ddm_]:SetPoint("LEFT", 0, 175)

		----------
		Sh_opt_createCP(cp_,L["Couleur_texte"], Shield_tex, var["font:val:r"], var["font:val:v"], var["font:val:b"])
		cp[cp_]:SetPoint("LEFT",230,150)

		cp[cp_]:SetScript("OnMouseDown", function() Sh_opt_showCP(var["font:val:r"], var["font:val:v"], var["font:val:b"], var["font:val:a"],Sh_opt_CPCallback,"font:val",unit) end)

		color_fontval_tex[cp_] = cp[cp_]:CreateTexture(nil,"BACKGROUND")
		color_fontval_tex[cp_]:SetTexture("Interface\\Buttons\\WHITE8X8")
		color_fontval_tex[cp_]:SetVertexColor(var["font:val:r"],var["font:val:v"],var["font:val:b"],var["font:val:a"])
		color_fontval_tex[cp_]:SetAllPoints(cp[cp_])
		
			 
		----------
		slider_=slider_+1 --2
		Sh_opt_createSlider(slider_, "Slider" .. slider_, Shield_tex, var["font:val:size"], 1, 30, "font:val:size", true, unit)
		slider[slider_]:SetPoint("CENTER", Shield_tex,"CENTER",70,120)


		local text_Shield_tex0 = Sh_opt_texte(L["Taille_texte"], 12,Shield_tex,1,1,1)
		text_Shield_tex0:SetPoint("LEFT", Shield_tex, 20, 120)

		----------
		cb[cb_] = Sh_opt_createCheckbox("cb" .. cb_, L["Contour"], Shield_tex)
		cb[cb_]:SetPoint("LEFT",20,150)
		cb[cb_]:SetChecked(var["contour"])
		cb[cb_]:Show()
		--------------------
		--------------------
		local text_Shield_tex4 = Sh_opt_texte(L["Apparence_generale"], 15,Shield_tex,0.8,0.8,0)
		text_Shield_tex4:SetPoint("LEFT", Shield_tex, 10, 55)

		----------
		slider_ = slider_+1 --3
		Sh_opt_createSlider(slider_, "Slider" .. slider_, Shield_tex, var["f:largeur"], var["f:largeur"]-100, var["f:largeur"]+100, "f:largeur", false, unit)
		slider[slider_]:SetPoint("CENTER", Shield_tex,"CENTER",70,35)


		local text_Shield_tex5 = Sh_opt_texte(L["Largeur_globale"], 12,Shield_tex,1,1,1)
		text_Shield_tex5:SetPoint("LEFT", Shield_tex, 20, 35)

		----------
		slider_ = slider_+1 --4
		Sh_opt_createSlider(slider_, "Slider" .. slider_, Shield_tex, var["f:hauteur"], 1, 100, "f:hauteur", true, unit)
		slider[slider_]:SetPoint("CENTER", Shield_tex,"CENTER",70,5)

		local text_Shield_tex6 = Sh_opt_texte(L["Hauteur_globale"], 12,Shield_tex,1,1,1)
		text_Shield_tex6:SetPoint("LEFT", Shield_tex, 20, 5)

		----------
		local text_Shield_tex7 = Sh_opt_texte(L["Texture_bordure_generale"], 12,Shield_tex,1,1,1)
		text_Shield_tex7:SetPoint("LEFT", Shield_tex, 20, -20)

		ddm_=ddm_+1 --
		Sh_opt_createDDM(ddm_, Shield_tex, 240, M_border, "f:tex:border", "border", unit)
		Sh_DDM[ddm_]:SetPoint("LEFT", 0, -40)

		----------
		slider_ = slider_+1 --5
		Sh_opt_createSlider(slider_, "Slider" .. slider_, Shield_tex, var["border:size"], 0, 50, "border:size", true, unit)
		slider[slider_]:SetPoint("CENTER", Shield_tex,"CENTER",70,-75)


		local text_Shield_tex11 = Sh_opt_texte(L["Taille_bordure"], 12,Shield_tex,1,1,1)
		text_Shield_tex11:SetPoint("LEFT", Shield_tex, 20, -75)

		---------
		local text_Shield_tex16 = Sh_opt_texte(L["insets"], 12,Shield_tex,1,1,1)
		text_Shield_tex16:SetPoint("LEFT", Shield_tex, 20, -90)  
		---------
		slider_=slider_+5--10
		Sh_opt_createSlider(slider_, "Slider" .. slider_, Shield_tex, var["insets:left"], 0, 20, "insets:left", true, unit)
		slider[slider_]:SetPoint("LEFT", Shield_tex,"LEFT",20,-115)
		slider[slider_]:SetWidth(50)
		slidermoins[slider_]:Hide()
		sliderplus[slider_]:Hide()
		local text_Shield_tex14 = Sh_opt_texte(L["left"], 12,Shield_tex,1,1,1)
		text_Shield_tex14:SetPoint("LEFT", Shield_tex, 25, -135)  

		slider_=slider_+1 --11
		Sh_opt_createSlider(slider_, "Slider" .. slider_, Shield_tex, var["insets:right"], 0, 20, "insets:right", true, unit)
		slider[slider_]:SetPoint("LEFT", Shield_tex,"LEFT",85,-115)
		slider[slider_]:SetWidth(50)
		slidermoins[slider_]:Hide()
		sliderplus[slider_]:Hide()
		local text_Shield_tex15 = Sh_opt_texte(L["right"], 12,Shield_tex,1,1,1)
		text_Shield_tex15:SetPoint("LEFT", Shield_tex, 90, -135) 

		slider_=slider_+1 --12
		Sh_opt_createSlider(slider_, "Slider" .. slider_, Shield_tex, var["insets:top"], 0, 20, "insets:top", true, unit)
		slider[slider_]:SetPoint("LEFT", Shield_tex,"LEFT",150,-115)
		slider[slider_]:SetWidth(50)
		slidermoins[slider_]:Hide()
		sliderplus[slider_]:Hide()
		local text_Shield_tex15 = Sh_opt_texte(L["top"], 12,Shield_tex,1,1,1)
		text_Shield_tex15:SetPoint("LEFT", Shield_tex, 155, -135) 

		slider_=slider_+1 --13
		Sh_opt_createSlider(slider_, "Slider" .. slider_, Shield_tex, var["insets:bottom"], 0, 20, "insets:bottom", true, unit)
		slider[slider_]:SetPoint("LEFT", Shield_tex,"LEFT",215,-115)
		slider[slider_]:SetWidth(50)
		slidermoins[slider_]:Hide()
		sliderplus[slider_]:Hide()
		local text_Shield_tex15 = Sh_opt_texte(L["bottom"], 12,Shield_tex,1,1,1)
		text_Shield_tex15:SetPoint("LEFT", Shield_tex, 220, -135) 

		-----------------------------------------------------------------------
		local text_Shield_tex8 = Sh_opt_texte(L["Texture_fond"], 12,Shield_tex,1,1,1)
		text_Shield_tex8:SetPoint("LEFT", Shield_tex, 20, -155)
		
		ddm_=ddm_+1 --4
		Sh_opt_createDDM(ddm_, Shield_tex, 240, M_background, "f:tex:fond", "background", unit)
		Sh_DDM[ddm_]:SetPoint("LEFT", 0, -175)

		---------
		cp_=cp_+1 --2
		Sh_opt_createCP(cp_,L["Couleur_fond"], Shield_tex, var["f:SBC:r"], var["f:SBC:v"], var["f:SBC:b"])
		cp[cp_]:SetPoint("LEFT",230,-200)

		cp[cp_]:SetScript("OnMouseDown", function() Sh_opt_showCP(var["f:SBC:r"], var["f:SBC:v"], var["f:SBC:b"], var["f:SBC:a"],Sh_opt_CPCallback,"f:SBC",unit) end)
		
		color_fontval_tex[cp_] = cp[cp_]:CreateTexture(nil,"BACKGROUND")
		color_fontval_tex[cp_]:SetTexture(var["f:tex:fond"])
		color_fontval_tex[cp_]:SetVertexColor(var["f:SBC:r"],var["f:SBC:v"],var["f:SBC:b"],var["f:SBC:a"])
		color_fontval_tex[cp_]:SetAllPoints(cp[cp_])

		----------
		if unit ~= "dk" then
			slider_=slider_-7 --6
			Sh_opt_createSlider(slider_, "Slider" .. slider_, Shield_tex, var["iconsize"], 0, 100, "iconsize", true, unit)
			slider[slider_]:SetPoint("CENTER", Shield_tex,"CENTER",70,-225)

			local text_Shield_tex9 = Sh_opt_texte(L["Taille_icones"], 12,Shield_tex,1,1,1,"LEFT", 20, -207)
			text_Shield_tex9:SetPoint("LEFT", Shield_tex, 20, -225)
		end
		

		slider_=slider_+1 --6
		Sh_opt_createSlider(slider_, "Slider" .. slider_, Shield_tex, var["level"], 1, 100, "level", true, unit)
		slider[slider_]:SetPoint("CENTER", Shield_tex,"CENTER",70,-250)

		local text_Shield_tex10 = Sh_opt_texte(L["level"], 12,Shield_tex,1,1,1,"LEFT", 20, -247)
		text_Shield_tex10:SetPoint("LEFT", Shield_tex, 20, -250)
		
		------------------------------------
		------------------------------------
		
		local Shield_check = CreateFrame("frame", "Shield_check", parent)
		Shield_check:SetFrameStrata("HIGH")
		Shield_check:SetBackdrop({
			bgFile = "empty", 
			edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
			edgeSize = 11,
		});
		Shield_check:SetBackdropColor(1,0,0,0)
		Shield_check:SetPoint("TOPLEFT",parent,"CENTER",0,-50)
		Shield_check:SetPoint("BOTTOMRIGHT",parent,"BOTTOMRIGHT",-5,5)
		Shield_check:Show()


		local text_Shield_check = Shield_check:CreateFontString("texteOption","MEDIUM","GameFontNormal")
		text_Shield_check:SetText(L["Options"])
		text_Shield_check:SetTextHeight(15)
		text_Shield_check:SetTextColor(0.8,0.8,0,1)
		text_Shield_check:SetPoint("TOPLEFT", Shield_check, 20, -5)
		text_Shield_check:Show()



		-----------------
		cb_ = cb_ - 4
		cb[cb_] = Sh_opt_createCheckbox("cb" .. cb_, L["Activer"], Shield_check)
		cb[cb_]:SetPoint("TOPLEFT",10,-30)
		cb[cb_]:SetChecked(O["enable"])
		cb[cb_]:Show()
		
		cb_ = cb_ + 1
		if unit == "player" then
			cb[cb_] = Sh_opt_createCheckbox("cb" .. cb_, L["Extase"], Shield_check)
			cb[cb_]:SetPoint("TOPLEFT",10,-65)
			cb[cb_]:SetChecked(Oo["enable_extase"])
			cb[cb_]:Show()
		end

		cb_ = cb_ + 1
		cb[cb_] = Sh_opt_createCheckbox("cb" .. cb_, L["short"], Shield_check)
		cb[cb_]:SetPoint("TOP",10,-30)
		cb[cb_]:SetChecked(O["short"])
		cb[cb_]:Show()

		cb_ = cb_ + 1
		if unit == "player" or unit == "target" then
			cb[cb_] = Sh_opt_createCheckbox("cb" .. cb_, L["blink"], Shield_check)
			cb[cb_]:SetPoint("TOP",10,-65)
			cb[cb_]:SetChecked(O["blink"])
			cb[cb_]:Show()
		end
	
	
	end
	
	
	Sh_lol(O,ShieldHealth.childpanel_player,0,1,1,1,5,"player")
	Sh_lol(Ot,ShieldHealth.childpanel_target,20,21,21,21,25,"target")
	Sh_lol(Odk,ShieldHealth.childpanel_dk,40,41,41,41,35,"dk")

   
   
   
   ------------------------------------------------------------------------------------
   ------------------------------------------------------------------------------------
   --------------------------------- ORDRE DES BOUCLIERS
   ------------------------------------------------------------------------------------
   ------------------------------------------------------------------------------------
    

   	local Shield_ordre = CreateFrame("frame", "Shield_ordre", ShieldHealth.childpanel_ordre)
	Shield_ordre:SetFrameStrata("HIGH")
	Shield_ordre:SetWidth(400)
	Shield_ordre:SetHeight(310)
	Shield_ordre:SetBackdrop({
        bgFile = "empty", 
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = 11,
	});
	Shield_ordre:SetBackdropColor(1,0,0,0)
	Shield_ordre:SetPoint("LEFT",10,115)
	Shield_ordre:Show()
	local text_Shield_ordre = Shield_ordre:CreateFontString("text_ordre","MEDIUM","GameFontNormal")
	text_Shield_ordre:SetText(L["Ordre"])
	text_Shield_ordre:SetTextHeight(15)
	text_Shield_ordre:SetTextColor(0.8,0.8,0,1)
	text_Shield_ordre:SetPoint("LEFT", Shield_ordre, 10, 130)
	text_Shield_ordre:Show()
	
 
   

   
	for j=1,9 do
		ordre[j] = CreateFrame("Frame","Ordre" .. j,Shield_ordre)
		ordre[j]:SetHeight(28)
		ordre[j]:SetWidth(350)
		--ordre[j]:SetPoint("LEFT",20,135-(30*Oo["Ord"][j]))
		ordre[j]:SetBackdrop({
			bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", 
			edgeFile = "empty",
		})
		ordre[j]:SetBackdropColor(O[j .. ":r"],O[j .. ":v"],O[j .. ":b"],0.2)
		ordre[j]:Show()
		
		text_ordre[j] = ordre[j]:CreateFontString("text","MEDIUM","GameFontNormal")
		text_ordre[j]:SetText(B[j])
		text_ordre[j]:SetTextHeight(14)
		text_ordre[j]:SetTextColor(1,1,1)
		text_ordre[j]:SetPoint("LEFT", ordre[j], 0, 0)
		text_ordre[j]:Show()
		
		
		up_ordre[j] =  CreateFrame("Button", "OrdreUp" .. j, ordre[j], "UIPanelScrollUpButtonTemplate")
		up_ordre[j]:SetPoint("LEFT", 198, 0)
		up_ordre[j]:SetScript("OnClick",function()
			for k=1,9 do 
				if Oo["Ord"][k] == j then
					if k ~= 1 then
						local _,_,_,_,x1 = ordre[j]:GetPoint()
						ordre[j]:SetPoint("LEFT",20,x1+30)
						
						ordre[Oo["Ord"][k-1] ]:SetPoint("LEFT",20,x1)
						Oo["Ord"][k],Oo["Ord"][k-1] = Oo["Ord"][k-1],Oo["Ord"][k]
						break
					end
				end
			end
		end)
		up_ordre[j]:SetWidth(20)
		up_ordre[j]:Show()
		
		
		down_ordre[j] =  CreateFrame("Button", "OrdreDown" .. j, ordre[j], "UIPanelScrollDownButtonTemplate")
		down_ordre[j]:SetPoint("LEFT", 217, 0)
		down_ordre[j]:SetScript("OnClick",function()
					for k=1,9 do 
						if Oo["Ord"][k] == j then
							if k ~= 9 then
								local _,_,_,_,x1 = ordre[j]:GetPoint()
								ordre[j]:SetPoint("LEFT",20,x1-30)
							
								ordre[Oo["Ord"][k+1] ]:SetPoint("LEFT",20,x1)
								Oo["Ord"][k],Oo["Ord"][k+1] = Oo["Ord"][k+1],Oo["Ord"][k]
								break
							end
						end
					end
				end
			)
		down_ordre[j]:SetWidth(20)
		down_ordre[j]:Show()
		
		
		toggle_ordre[j] = Sh_opt_createCheckbox("OrdreToggleCb" .. j, "", ordre[j])
		toggle_ordre[j]:SetPoint("LEFT",260,0)
		toggle_ordre[j]:SetChecked(Oo["Ord:toggle"][j])
		toggle_ordre[j]:SetScript("OnClick",function()
					Oo["Ord:toggle"][j] = toggle_ordre[j]:GetChecked()
					Sh_OnEvent()
				end
			)
		toggle_ordre[j]:Show()
		
		
		toggle_icon[j] = Sh_opt_createCheckbox("OrdreIconCb" .. j, "", ordre[j])
		toggle_icon[j]:SetPoint("LEFT",310,0)
		toggle_icon[j]:SetChecked(Oo["Ord:icon"][j])
		toggle_icon[j]:SetScript("OnClick",function()
					Oo["Ord:icon"][j] = toggle_icon[j]:GetChecked()
					Sh_OnEvent()
				end
			)
		toggle_icon[j]:Show()
	end
	local toggle_ordre_text = Sh_opt_texte(L["Activer"], 12,Shield_ordre,1,1,1,"LEFT", 270, 130)
	toggle_ordre_text:SetPoint("LEFT", Shield_ordre, 270, 125)
	
	local toggle_icon_text = Sh_opt_texte(L["Icone"], 12,Shield_ordre,1,1,1,"LEFT", 325, 130)
	toggle_icon_text:SetPoint("LEFT", Shield_ordre, 325, 125)
	
   
   ------------------------------------------------------------------------------------
   ------------------------------------------
   Sh_refresh()
   
end
------------------------------------------







function Sh_test()
if TESTMODE then



	ft1tar:SetText(L["target"])


	ftar:Show()
	i1tar:Hide()
	i2tar:Hide()

  
	i1_textar:SetTexture(Btex[5])
	i1tar:Show()
	i1CDtar:SetCooldown(GetTime(),15)
	i2_textar:SetTexture(Btex[6])
	i2tar:Show()
	i2CDtar:SetCooldown(GetTime()-2,15)
	

	fbtar:SetPoint("LEFT",Ot["iconsize"]*2 + Ot["insets:left"],((Ot["insets:bottom"]-Ot["insets:top"])/2))
	fbtar:SetWidth(Ot["f:largeur"]-(Ot["iconsize"]*2 + Ot["insets:left"]+Ot["insets:right"]))
	fb2tar:SetPoint("LEFT",Ot["iconsize"]*2 + Ot["insets:left"],((Ot["insets:bottom"]-Ot["insets:top"])/2))
	fb2tar:SetWidth(Ot["f:largeur"]-(Ot["iconsize"]*2 + Ot["insets:left"]+Ot["insets:right"]))

	
	for j=1,9 do Bftar[j]:SetWidth(1) Bf[j]:Hide() end
	
	Bftar[5]:Show()
	Bftar[5]:SetWidth((Ot["f:largeur"]-(Ot["iconsize"]*2 + Ot["insets:left"]+Ot["insets:right"]))/4)
	Bftar[5]:SetPoint("LEFT",0,0)
	
	Bftar[6]:Show()
	Bftar[6]:SetWidth((Ot["f:largeur"]-(Ot["iconsize"]*2 + Ot["insets:left"]+Ot["insets:right"]))/2.5)
	Bftar[6]:SetPoint("LEFT",Bftar[5]:GetWidth(),0)
	

	
	
	
	
	
	ft1:SetText(L["player"])
	

	f:Show()
	i1:Hide()
	i2:Hide()

  
	i1_tex:SetTexture(Btex[1])
	i1:Show()
	i1CD:SetCooldown(GetTime(),60)
	i2_tex:SetTexture(Btex[2])
	i2:Show()
	i2CD:SetCooldown(GetTime()-10,60)
	

	fb:SetPoint("LEFT",O["iconsize"]*2 + O["insets:left"],((O["insets:bottom"]-O["insets:top"])/2))
	fb:SetWidth(O["f:largeur"]-(O["iconsize"]*2 + O["insets:left"]+O["insets:right"]))
	fb2:SetPoint("LEFT",O["iconsize"]*2 + O["insets:left"],((O["insets:bottom"]-O["insets:top"])/2))
	fb2:SetWidth(O["f:largeur"]-(O["iconsize"]*2 + O["insets:left"]+O["insets:right"]))

	Bf[1]:Show()
	Bf[1]:SetWidth((O["f:largeur"]-(O["iconsize"]*2 + O["insets:left"]+O["insets:right"]))/2)
	Bf[1]:SetPoint("LEFT",0,0)
	
	Bf[2]:Show()
	Bf[2]:SetWidth((O["f:largeur"]-(O["iconsize"]*2 + O["insets:left"]+O["insets:right"]))/4)
	Bf[2]:SetPoint("LEFT",Bf[1]:GetWidth(),0)
	
	for j=3,9 do Bf[j]:SetWidth(1) Bf[j]:Hide() end
	
	
	
	if Odk["enable"] then
	
	ft1DK:SetText(L["dk"])
	

	bgDK:Show()
	fDK:Show()

	fbDK:SetPoint("LEFT",Odk["insets:left"],((Odk["insets:bottom"]-Odk["insets:top"])/2))
	fbDK:SetWidth(Odk["f:largeur"]-(Odk["insets:left"]+Odk["insets:right"]))
	fb2DK:SetPoint("LEFT",Odk["insets:left"],((Odk["insets:bottom"]-Odk["insets:top"])/2))
	fb2DK:SetWidth(Odk["f:largeur"]-(Odk["insets:left"]+Odk["insets:right"]))

	BfDK:Show()
	BfDK:SetWidth((Odk["f:largeur"]-(Odk["insets:left"]+Odk["insets:right"]))/3)
	BfDK:SetPoint("LEFT",0,0)
	end
end
end

function Sh_reset()
	for j=1,9 do
	ordre[j]:SetPoint("LEFT",20,110-(25*Oo["Ord"][j]))
	end

	Sh_options()
	Sh_DB[PROFILE]["O"] = O
	Sh_DB[PROFILE]["Ot"] = Ot
	Sh_DB[PROFILE]["Odk"] = Odk
	Sh_DB[PROFILE]["Oo"] = Oo
	Sh_refresh_options()
	Sh_refresh()
	Sh_print(L["reset3"] .. PROFILE .. L["reset4"])
end


-----------------------------
function Sh_deep (t, done)
-- Copie de tables
-- Source : http://www.gammon.com.au/forum/?id=8042
-----------------------------
  assert (type (t) == "table", "You must specify a table to copy")

  local result = {}
  done = done or {}

  assert (not done [t], "table is defined within itself")

  done [t] = true -- we will disallow recopying table t

  for k, v in pairs (t) do
    if type (v) == "table"  then
      result [k] = Sh_deep (v, done)
    else
      result [k] = v
    end -- if table or not
  end -- for each table element

  done [t] = nil -- table t can be copied again

  -- copy the metatable
  return setmetatable (result, getmetatable (t))

end -- function deep


function Sh_print(text)
DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff[ShieldHealth] |r" .. text)
end

Sh_OnLoad()